/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicMapImageryView } from "./GeographicMapImageryView";
import { SubDomainsCollection } from "./SubDomainsCollection";
import { GeographicMapImagery } from "./GeographicMapImagery";
import { BingMapsTileSource } from "igniteui-webcomponents-core";
import { markType, String_$type, enumGetBox, runOn, delegateRemove, delegateCombine, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { BingMapsImageryStyle_$type } from "./BingMapsImageryStyle";
import { List$1 } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { HttpRequestUtil } from "igniteui-webcomponents-core";
import { Uri } from "igniteui-webcomponents-core";
import { stringEmpty, stringIsNullOrEmpty } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let BingMapsMapImageryView = /*@__PURE__*/ (() => {
    class BingMapsMapImageryView extends GeographicMapImageryView {
        constructor(a) {
            super(a);
            this.k = a;
        }
        m() {
            if (this.k.subDomains == null) {
                this.k.subDomains = new SubDomainsCollection(0);
            }
            this.k.ap.tilePath = this.k.actualTilePath;
            this.k.ap.subDomains = this.k.actualSubDomains;
            this.k.ap.cultureName = this.k.cultureName;
        }
        o() {
            this.k.ap.tilePath = this.k.actualTilePath;
        }
        l() {
            this.k.ap.cultureName = this.k.cultureName;
        }
        n() {
            this.k.ap.subDomains = this.k.actualSubDomains;
        }
    }
    BingMapsMapImageryView.$t = /*@__PURE__*/ markType(BingMapsMapImageryView, 'BingMapsMapImageryView', GeographicMapImageryView.$);
    return BingMapsMapImageryView;
})();
/**
 * @hidden
 */
export let BingMapsMapImagery = /*@__PURE__*/ (() => {
    class BingMapsMapImagery extends GeographicMapImagery {
        constructor() {
            super(new BingMapsTileSource(0));
            this._pendingBingRequest_ = null;
            this._isInitialized = false;
            this.bz = null;
            this.bq = null;
            this.b0 = null;
            this.by = null;
            this.getResponseCompleted = this.getResponseCompleted.bind(this);
            this.bp.m();
            this.actualBingImageryRestUri = BingMapsMapImagery.cc;
        }
        ai() {
            return new BingMapsMapImageryView(this);
        }
        bb(a) {
            super.bb(a);
            this.bp = a;
        }
        get isInitialized() {
            return this._isInitialized;
        }
        set isInitialized(a) {
            this._isInitialized = a;
        }
        get actualTilePath() {
            return this.bz;
        }
        set actualTilePath(a) {
            let b = this.bz;
            this.bz = a;
            this.cm("ActualTilePath", b, this.bz);
        }
        get actualSubDomains() {
            return this.bq;
        }
        set actualSubDomains(a) {
            let b = this.bq;
            this.bq = a;
            this.cm("ActualSubDomains", b, this.bq);
        }
        get bingImageryRestUri() {
            return this.b0;
        }
        set bingImageryRestUri(a) {
            let b = this.b0;
            this.b0 = a;
            this.cm("BingImageryRestUri", b, this.b0);
        }
        get actualBingImageryRestUri() {
            return this.by;
        }
        set actualBingImageryRestUri(a) {
            let b = this.by;
            this.by = a;
            this.ba("ActualBingImageryRestUri", b, this.by);
        }
        requestMapSettings() {
            this.co(true);
        }
        co(a) {
            this.cl(a);
        }
        bw() {
            if ((this.tilePath == null) && (this.subDomains == null)) {
                return true;
            }
            return false;
        }
        cq() {
            this.isInitialized = false;
            if (!this.bv()) {
                this.cp("", null);
                return;
            }
            if (!this.isDeferredLoad) {
                this.co(false);
            }
        }
        bv() {
            if (stringIsNullOrEmpty(this.apiKey) || this.apiKey.length < 20) {
                return false;
            }
            return true;
        }
        cj() {
        }
        cp(a, b) {
            if (a != this.actualTilePath) {
                this.actualTilePath = a;
            }
            let c = b == null ? null : new SubDomainsCollection(1, b);
            if (this.actualSubDomains != c) {
                this.actualSubDomains = c;
            }
            this.bp.m();
        }
        cl(a) {
            if ((!a) && (this.isDeferredLoad)) {
                return;
            }
            if (!this.bv()) {
                this.isInitialized = false;
                this.cp("", null);
                return;
            }
            this.isInitialized = true;
            let b = null;
            if (this.bingImageryRestUri != null) {
                if (Uri.isWellFormedUriString(this.bingImageryRestUri, 1)) {
                    b = this.bingImageryRestUri;
                }
            }
            else {
                if (Uri.isWellFormedUriString(this.actualBingImageryRestUri, 1)) {
                    b = this.actualBingImageryRestUri;
                }
            }
            if (b == null) {
                this.cp("", null);
                return;
            }
            let c = this.imageryStyle;
            b += enumGetBox(BingMapsImageryStyle_$type, c);
            let d = "key=" + this.apiKey + "&include=ImageryProviders";
            let url_ = b + "?" + d;
            this._pendingBingRequest_ = HttpRequestUtil.submit(url_, this.getResponseCompleted, null);
        }
        getResponseCompleted(a, b) {
            if (b != this._pendingBingRequest_) {
                return;
            }
            this._pendingBingRequest_ = null;
            let data_ = a;
            let resourceSets_ = JSON.parse(data_).resourceSets;
            if (resourceSets_ == null) {
                return;
            }
            let resources_ = resourceSets_.length > 0 ? resourceSets_[0].resources : null;
            if (resources_ == null) {
                return;
            }
            if (resources_.length == 0) {
                return;
            }
            ;
            let imageUrl_ = (resources_[0].imageUrl);
            let subDomains_ = new List$1(String_$type, 0);
            for (var i = 0; i < resources_[0].imageUrlSubdomains.length; i++) {
                subDomains_.add(resources_[0].imageUrlSubdomains[i]);
            }
            ;
            this.cp(imageUrl_, subDomains_);
        }
        ci(a, b) {
            this.aj.e();
            this.cq();
            this.cm(BingMapsMapImagery.$$p[4], this.actualSubDomains, this.actualSubDomains);
        }
        cm(a, b, c) {
            switch (a) {
                case BingMapsMapImagery.$$p[0]:
                    this.cq();
                    break;
                case BingMapsMapImagery.$$p[3]:
                    this.cq();
                    break;
                case BingMapsMapImagery.$$p[5]:
                    this.cj();
                    this.actualTilePath = c;
                    this.bp.o();
                    this.aj.e();
                    break;
                case BingMapsMapImagery.$$p[1]:
                    this.bp.l();
                    this.aj.e();
                    break;
                case BingMapsMapImagery.$$p[2]:
                    this.cq();
                    break;
                case BingMapsMapImagery.$$p[4]:
                    this.cj();
                    let d = b;
                    let e = c;
                    if (this.actualSubDomains != null) {
                        let f = this.actualSubDomains;
                        f.collectionChanged = delegateRemove(f.collectionChanged, runOn(this, this.ci));
                    }
                    this.actualSubDomains = e;
                    if (this.actualSubDomains != null) {
                        e.collectionChanged = delegateCombine(e.collectionChanged, runOn(this, this.ci));
                    }
                    this.bp.n();
                    this.aj.e();
                    break;
                case "ActualTilePath":
                    let g = c;
                    if (stringIsNullOrEmpty(g)) {
                        this.cq();
                    }
                    break;
                case "BingImageryRestUri":
                    this.actualBingImageryRestUri = c;
                    this.cj();
                    this.cq();
                    break;
                case "ActualBingImageryRestUri":
                    this.cj();
                    this.cq();
                    break;
            }
            super.ba(a, b, c);
        }
    }
    BingMapsMapImagery.$t = /*@__PURE__*/ markType(BingMapsMapImagery, 'BingMapsMapImagery', GeographicMapImagery.$);
    BingMapsMapImagery.cc = "http://dev.virtualearth.net/REST/v1/Imagery/Metadata/";
    BingMapsMapImagery.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BingMapsMapImagery, 'cm', ['ApiKey', [2, /*@__PURE__*/ stringEmpty()], 'CultureName', [2, "en-US"], 'ImageryStyle', [BingMapsImageryStyle_$type, /*@__PURE__*/ enumGetBox(BingMapsImageryStyle_$type, 1)], 'IsDeferredLoad', [0, false], 'SubDomains', [SubDomainsCollection.$, null], 'TilePath', [2, null]]);
    return BingMapsMapImagery;
})();
