/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SeriesViewer } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { MapResizeBehavior_$type } from "./MapResizeBehavior";
import { MapBackgroundTilingMode_$type } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-webcomponents-core";
import { Base, Boolean_$type, typeCast, enumGetBox, Point_$type, fromEnum, Number_$type, runOn, delegateRemove, delegateCombine, markType, markDep, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, IEnumerable_$type } from "igniteui-webcomponents-core";
import { NumericXAxis } from "igniteui-webcomponents-charts";
import { NumericYAxis } from "igniteui-webcomponents-charts";
import { SphericalMercatorVerticalScaler } from "./SphericalMercatorVerticalScaler";
import { Control } from "igniteui-webcomponents-core";
import { SphericalMercatorHorizontalScaler } from "./SphericalMercatorHorizontalScaler";
import { ScalerParams } from "igniteui-webcomponents-charts";
import { SeriesViewerView } from "igniteui-webcomponents-charts";
import { Tuple$2 } from "igniteui-webcomponents-core";
import { MathUtil } from "igniteui-webcomponents-core";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { ItfConverter } from "igniteui-webcomponents-core";
import { ChartVisualData } from "igniteui-webcomponents-charts";
import { RectData } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-webcomponents-core";
import { XamMultiScaleImage } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ScatterAreaSeries } from "igniteui-webcomponents-charts";
import { BrushCollection } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { OpenStreetMapTileSource } from "igniteui-webcomponents-core";
import { ColorScale } from "igniteui-webcomponents-charts";
/**
 * @hidden
 */
export let XamGeographicMap = /*@__PURE__*/ (() => {
    class XamGeographicMap extends SeriesViewer {
        constructor() {
            super();
            this.u3 = null;
            this.us = false;
            this.uk = 1;
            this.uz = 0;
            this.wa = null;
            this.uh = null;
            this.ud = null;
            this.uf = null;
            this.uj = null;
            this.v6 = { $type: Point_$type, x: NaN, y: NaN };
            this.wd = null;
            this.uy = 1;
            this.imageTilesReady = null;
            this.ur = null;
            this.wc = Rect.empty;
            this.uz = SphericalMercatorVerticalScaler.am(XamGeographicMap.wb.bottom) - SphericalMercatorVerticalScaler.am(XamGeographicMap.wb.top);
            this.ab = XamGeographicMap.$;
            this.backgroundContent = new OpenStreetMapImagery();
            let a = ((() => {
                let $ret = new NumericXAxis();
                $ret.bi = this;
                return $ret;
            })());
            a.cf = true;
            this.ue = a;
            this.ue.nl = new SphericalMercatorHorizontalScaler();
            let b = ((() => {
                let $ret = new NumericYAxis();
                $ret.bi = this;
                return $ret;
            })());
            b.cf = true;
            this.ug = b;
            this.ug.nl = new SphericalMercatorVerticalScaler();
            this.vl();
            this.vs();
            this.me();
        }
        provideContainer(a) {
            super.provideContainer(a);
            this.ue.provideRenderer(a);
            this.ug.provideRenderer(a);
        }
        me() {
            super.me();
            this.uq.fv(this.gi);
        }
        ev() {
            return this.uw;
        }
        ew() {
            return this.uw;
        }
        un() {
            if (this.ul == 0) {
                if (this.us) {
                    return 2;
                }
            }
            return 1;
        }
        get um() {
            return this.uk;
        }
        set um(a) {
            this.uk = a;
        }
        get wf() {
            return this.wa;
        }
        set wf(a) {
            let b = Rect.l_op_Inequality(this.wa, a);
            if (b) {
                let c = this.wa;
                this.wa = a;
                this.op("ActualWorldRect", c, a);
            }
        }
        wj() {
            return this.wf;
        }
        vl() {
            if (this.wr.isEmpty) {
                return;
            }
            this.wf = this.wp(this.wr, this.cd == 1);
        }
        wp(a, b) {
            let c = a.top;
            let d = a.left;
            let e = a.width;
            let f = a.height;
            let g = SphericalMercatorVerticalScaler.am(a.bottom);
            let h = SphericalMercatorVerticalScaler.am(a.top);
            let i = g - h;
            let j = a.width / XamGeographicMap.wb.width;
            let k = SphericalMercatorVerticalScaler.am(XamGeographicMap.wb.top);
            let l = i / j;
            if (i / j > this.uz) {
                let m = i / this.uz;
                let n = m - j;
                d = d - (n / 2) * XamGeographicMap.wb.width;
                e = m * XamGeographicMap.wb.width;
                if (b) {
                    if (d < XamGeographicMap.wb.left) {
                        d += (XamGeographicMap.wb.left - d);
                    }
                    else if ((d + e) > XamGeographicMap.wb.right) {
                        d -= ((d + e) - XamGeographicMap.wb.right);
                    }
                }
            }
            else if (i / j < this.uz) {
                let o = this.uz * j;
                let p = o - i;
                let q = h - (p / 2);
                let r = g + (p / 2);
                if (b) {
                    if (q < k) {
                        q += (k - q);
                        r += (k - q);
                    }
                    else if (r > (k + this.uz)) {
                        q -= ((r) - (k + this.uz));
                        r -= ((r) - (k + this.uz));
                    }
                }
                c = SphericalMercatorVerticalScaler.aq(q);
                f = SphericalMercatorVerticalScaler.aq(r) - c;
            }
            let s = new Rect(0, d, c, e, f);
            return s;
        }
        get backgroundContent() {
            return this.uh;
        }
        set backgroundContent(a) {
            let b = a != this.backgroundContent;
            if (b) {
                let c = this.backgroundContent;
                this.uh = a;
                this.op("BackgroundContent", c, a);
            }
        }
        get ue() {
            return this.ud;
        }
        set ue(a) {
            let b = a != this.ue;
            if (b) {
                let c = this.ue;
                this.ud = a;
                this.op("XAxis", c, a);
            }
        }
        get ug() {
            return this.uf;
        }
        set ug(a) {
            let b = a != this.ug;
            if (b) {
                let c = this.ug;
                this.uf = a;
                this.op("YAxis", c, a);
            }
        }
        getZoomRectFromGeoRect(a) {
            return this.getZoomFromGeographicRect(a);
        }
        vv(a) {
            this.t7 = a;
        }
        vu(a) {
            this.wr = a;
        }
        getZoomFromGeographicRect(a) {
            return this.wh(a, true, 0);
        }
        wg(a, b) {
            return this.wh(a, false, b);
        }
        wh(a, b, c) {
            let d = a;
            if (b) {
                d = this.wp(a, false);
            }
            let e = this.ue;
            let f = this.ug;
            let g = new ScalerParams(1, XamGeographicMap.we, this.t6, e.ch);
            g.c = this.tv;
            let h = new ScalerParams(1, XamGeographicMap.we, this.t6, f.ch);
            h.c = this.tv;
            let i = this.ue.ej(d.left, g);
            let j = this.ue.ej(d.right, g);
            let k = this.ug.ej(d.top, h);
            let l = this.ug.ej(d.bottom, h);
            let m = (i - c) / this.t6.width;
            let n = (l - c) / this.t6.height;
            let o = (j - i + (c * 2)) / this.t6.width;
            let p = (k - l + (c * 2)) / this.t6.height;
            let q = new Rect(0, m, n, o, p);
            q.intersect(XamGeographicMap.we);
            if (q.isEmpty) {
                q = XamGeographicMap.we;
            }
            return q;
        }
        getZoomFromGeographicPoints(a, b) {
            let c = a.x;
            let d = b.y;
            let e = b.x - a.x;
            let f = a.y - b.y;
            if (e < 0 || f < 0) {
                return XamGeographicMap.we;
            }
            else {
                let g = new Rect(0, c, d, e, f);
                return this.getZoomFromGeographicRect(g);
            }
        }
        wl(a) {
            let b = this.ue;
            let c = this.ug;
            let d = new ScalerParams(1, a, this.t6, b.ch);
            d.c = this.tv;
            let e = new ScalerParams(1, a, this.t6, c.ch);
            e.c = this.tv;
            let f = this.tu;
            let g = b.em(f.left, d);
            let h = c.em(f.top, e);
            let i = b.em(f.right, d);
            let j = c.em(f.bottom, e);
            let k = i - g;
            let l = h - j;
            let m = new Rect(0, g, j, k, l);
            if (this.cd == 1) {
                m.intersect(XamGeographicMap.wb);
                if (m.isEmpty) {
                    m = XamGeographicMap.wb;
                }
            }
            return m;
        }
        v7(a) {
            let b = this.ue.l8(a.x);
            let c = this.ug.l8(a.y);
            return { $type: Point_$type, x: b, y: c };
        }
        v8(a) {
            let b = this.ue.e4(a.x);
            let c = this.ug.e4(a.y);
            return { $type: Point_$type, x: b, y: c };
        }
        v9(a) {
            return this.v8(a);
        }
        vi() {
            let a = typeCast(GeographicMapImagery.$, this.backgroundContent);
            if (a != null) {
                a.clearTileCache();
            }
        }
        vo(a) {
        }
        fk() {
            return true;
        }
        vq() {
            this.uq.ee();
            for (let a of fromEnum(this.series)) {
                a.qa();
            }
        }
        vt() {
            if (this.up == 2) {
                if (!this.t6.isEmpty && this.t6.width > 0 && this.t6.height > 0) {
                    let a = this.ue.l8(this.t6.left + (this.t6.width / 2));
                    let b = this.ug.l8(this.t6.top + (this.t6.height / 2));
                    this.v6 = { $type: Point_$type, x: a, y: b };
                }
            }
            else {
                if (!this.t6.isEmpty && this.t6.width > 0 && this.t6.height > 0) {
                    let c = this.ue.l8(this.t6.left);
                    let d = this.ug.l8(this.t6.top);
                    this.v6 = { $type: Point_$type, x: c, y: d };
                }
            }
        }
        vp() {
            if (isNaN_(this.v6.x) || isNaN_(this.v6.y)) {
                this.vt();
            }
            let a = this.v6.x;
            let b = this.v6.y;
            if (!isNaN_(a) && !isNaN_(b)) {
                let c = this.tr.left;
                let d = this.tr.top;
                let e = this.tr.width;
                let f = this.tr.height;
                if (e > this.wd.width) {
                }
                else {
                    let g = new ScalerParams(1, XamGeographicMap.we, this.t6, this.ue.ch);
                    g.c = this.tv;
                    let h = this.ue.ej(a, g);
                    if (this.up == 2) {
                        let i = h / this.t6.width;
                        c = i - (e / 2);
                    }
                    else {
                        c = h / this.t6.width;
                    }
                    if (c + e > this.wd.right) {
                        c = this.wd.right - e;
                    }
                    else if (c < this.wd.left) {
                        c = this.wd.left;
                    }
                }
                if (f > this.wd.height) {
                }
                else {
                    let j = new ScalerParams(1, XamGeographicMap.we, this.t6, this.ug.ch);
                    j.c = this.tv;
                    let k = this.ug.ej(b, j);
                    if (this.up == 2) {
                        let l = k / this.t6.height;
                        d = l - (f / 2);
                    }
                    else {
                        d = k / this.t6.height;
                    }
                    if (d + f > this.wd.bottom) {
                        d = this.wd.bottom - f;
                    }
                    else if (d < this.wd.top) {
                        d = this.wd.top;
                    }
                }
                this.py(new Rect(0, c, d, e, f), false);
            }
        }
        get_en() {
            return true;
        }
        ts() {
            let a = super.ts();
            if (this.ue == null || this.ug == null) {
                return a;
            }
            this.t2();
            let b = a.left;
            let c = a.top;
            if (this.cd == 1) {
                if (this.t7.width > this.wd.width) {
                    b = 0.5 - (this.t7.width / 2);
                }
                else if (b + a.width > this.wd.right) {
                    b = this.wd.right - this.t7.width;
                }
                else if (b < this.wd.left) {
                    b = this.wd.left;
                }
                if (this.t7.height > this.wd.height) {
                    c = 0.5 - (this.t7.height / 2);
                }
                else if (c + this.t7.height > this.wd.bottom) {
                    c = this.wd.bottom - this.t7.height;
                }
                else if (c < this.wd.top) {
                    c = this.wd.top;
                }
            }
            let d = false;
            if (!this.uv && this.cd == 2 && this.us) {
                if (b > 1) {
                    b = (b - Math.floor(b)) + 1;
                }
                if (b < 0) {
                    b = 0 - (Math.ceil(b) - b);
                }
                if ((a.right - this.wd.right) > 0 && ((a.right - this.wd.right) / a.width) > 0.8) {
                    b = this.wd.left - (a.width - (a.right - this.wd.right));
                    d = true;
                }
                else if (a.left < this.wd.left && (Math.abs(a.left - this.wd.left) / a.width) > 0.8) {
                    b = this.wd.right - (Math.abs(a.left - this.wd.left));
                    d = true;
                }
            }
            let e = new Rect(0, b, c, a.width, a.height);
            if (this.uv) {
                let f = this.wg(this.wr, 1);
                f = this.wi(f);
                let g = e.left + e.width / 2;
                let h = e.top + e.height / 2;
                if (e.width > f.width) {
                    let i = e.height / e.width;
                    let j = f.width;
                    let k = i * j;
                    e = new Rect(0, g - j / 2, h - k / 2, j, k);
                    d = true;
                }
                if (e.height > f.height) {
                    let l = e.width / e.height;
                    let m = f.height;
                    let n = l * m;
                    e = new Rect(0, g - n / 2, h - m / 2, n, m);
                    d = true;
                }
                if (e.left < f.left) {
                    e = new Rect(0, f.left, e.top, e.width, e.height);
                    d = true;
                }
                if (e.top < f.top) {
                    e = new Rect(0, e.left, f.top, e.width, e.height);
                    d = true;
                }
                if (e.right > f.right) {
                    e = new Rect(0, f.right - e.width, e.top, e.width, e.height);
                    d = true;
                }
                if (e.bottom > f.bottom) {
                    e = new Rect(0, e.left, f.bottom - e.height, e.width, e.height);
                    d = true;
                }
            }
            if (d) {
                this.ea = true;
                this.t7 = e;
                this.ea = false;
            }
            return e;
        }
        lp(a, b) {
            let c = true;
            let d = true;
            let e = 0;
            let f = this.t2();
            let g = 0;
            let h = 0;
            if ((a.right - f.right) > 0) {
                g = ((a.right - f.right) / a.width);
            }
            if (a.left < f.left) {
                h = (Math.abs(a.left - f.left) / a.width);
            }
            if (h == 0 && g == 0) {
                c = false;
            }
            if (h > g) {
                d = false;
            }
            if (c) {
                if (d) {
                    let i = this.ud.ej(-180, b);
                    let j = this.ud.ej(180, b);
                    e = j - i;
                }
                else {
                    let k = this.ud.ej(-180, b);
                    let l = this.ud.ej(180, b);
                    e = k - l;
                }
            }
            return new Tuple$2(Boolean_$type, Number_$type, c, e);
        }
        t2() {
            let a = new ScalerParams(1, XamGeographicMap.we, this.t6, this.ue.ch);
            a.c = this.tv;
            let b = new ScalerParams(1, XamGeographicMap.we, this.t6, this.ug.ch);
            b.c = this.tv;
            let c = this.ue.ej(XamGeographicMap.wb.left, a);
            let d = this.ue.ej(XamGeographicMap.wb.right, a);
            let e = this.ug.ej(XamGeographicMap.wb.top, b);
            let f = this.ug.ej(XamGeographicMap.wb.bottom, b);
            this.wd = new Rect(0, c / this.t6.width, f / this.t6.height, (d - c) / this.t6.width, (e - f) / this.t6.height);
            return this.wd;
        }
        wi(a) {
            let b = this.gm;
            let c = 0.5 * (a.left + a.right);
            let d = 0.5 * (a.top + a.bottom);
            let e = a.width;
            let f = a.height;
            let g = MathUtil.d(a.width, b, 1);
            let h = MathUtil.d(a.height, b, 1);
            let i = this.t6;
            let j = i.width / i.height;
            let k = g * i.width;
            let l = h * i.height;
            let m = k / l;
            if (m != j) {
                if (l * j > k) {
                    k = l * j;
                    g = k / i.width;
                }
                else {
                    l = k / j;
                    h = l / i.height;
                }
            }
            let n = g != e;
            let o = h != f;
            let p = n ? c - 0.5 * g : a.left;
            let q = o ? d - 0.5 * h : a.top;
            let r = n ? c + 0.5 * g : a.right;
            let s = o ? d + 0.5 * h : a.bottom;
            if (p < 0) {
                p = 0;
                r = p + g;
            }
            if (r > 1) {
                r = 1;
                p = r - g;
            }
            if (q < 0) {
                q = 0;
                s = q + h;
            }
            if (s > 1) {
                s = 1;
                q = s - h;
            }
            return new Rect(0, p, q, r - p, s - q);
        }
        tt(a) {
            super.tt(this.t6);
            if (a.isEmpty) {
                return Rect.empty;
            }
            let b;
            if (a.width > a.height) {
                let c = intDivide(truncate((a.width - a.height)), 2);
                b = new Rect(0, a.left + c, a.top, a.height, a.height);
            }
            else {
                let d = intDivide(truncate((a.height - a.width)), 2);
                b = new Rect(0, a.left, a.top + d, a.width, a.width);
            }
            return b;
        }
        wk(a) {
            return this.tt(a);
        }
        ct() {
            return new XamGeographicMapView(this);
        }
        vk(a) {
            if (a != null) {
                a.bi = this;
            }
        }
        n8(a) {
            super.n8(a);
            this.uq = a;
        }
        oj(a, b) {
            super.oj(a, b);
            this.pl(this.ue);
            this.pl(this.ug);
            if (Rect.l_op_Inequality(a, b)) {
                this.vp();
            }
            if (this.uv) {
                this.tr = this.ts();
            }
            this.vw();
        }
        get u0() {
            return this.uy;
        }
        set u0(a) {
            let b = this.uy;
            this.uy = a;
            this.op("ActualWindowScale", b, this.uy);
        }
        gs() {
            return this.u0;
        }
        gt() {
            return this.u0;
        }
        pk() {
            super.pk();
            let a = Math.min(this.tr.width, this.tr.height);
            this.u0 = a;
        }
        fc() {
            return this.us;
        }
        ce() {
            if (this.cf == 0) {
                if (this.ut) {
                    return 2;
                }
            }
            return this.cf;
        }
        ok(a, b, c, d) {
            super.ok(a, b, c, d);
            switch (b) {
                case "ZoomCoercionMode":
                    this.vl();
                    break;
                case "WindowRect":
                    this.vt();
                    break;
                case XamGeographicMap.$$p[0]:
                    this.um = this.un();
                    if (this.uj != null) {
                        this.uj.isHorizontalWrappingEnabled = this.um == 2;
                    }
                    break;
                case XamGeographicMap.$$p[1]:
                    this.us = this.ut;
                    this.um = this.un();
                    this.cd = this.ce();
                    if (this.uj != null) {
                        this.uj.isHorizontalWrappingEnabled = this.um == 2;
                    }
                    break;
                case XamGeographicMap.$$p[4]:
                    this.tr = this.ts();
                    break;
                case "BackgroundContent":
                    if (this.uj != null) {
                        let e = this.uj;
                        e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.vm));
                        this.uj.deferralHandler = null;
                    }
                    this.uj = typeCast(GeographicMapImagery.$, this.backgroundContent);
                    if (this.uj != null) {
                        let f = this.uj;
                        f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.vm));
                        this.uj.deferralHandler = this;
                        this.uj.isHorizontalWrappingEnabled = this.um == 2;
                    }
                    this.uq.fu(typeCast(GeographicMapImagery.$, c), typeCast(GeographicMapImagery.$, d));
                    if (this.uj != null) {
                        this.uj.geographicMap = this;
                        this.uq.fr(this.tr);
                        this.uq.fv(this.gi);
                    }
                    break;
                case "YAxis":
                case "XAxis":
                    this.vr(c);
                    this.vk(d);
                    break;
                case XamGeographicMap.$$p[6]:
                    if (!this.uu) {
                        this.t7 = XamGeographicMap.we;
                    }
                    this.vl();
                    this.vs();
                    this.vt();
                    this.tr = this.ts();
                    this.uq.fs();
                    break;
                case "ActualWindowRect":
                    this.uq.fr(this.tr);
                    break;
                case "ActualWorldRect":
                    for (let g of fromEnum(this.series)) {
                        g.pr(false);
                    }
                    break;
                case XamGeographicMap.$$p[5]:
                    this.u0 = this.u1;
                    break;
                case "ActualWindowScale":
                    if (!this.fj) {
                        this.pw(this.gs(), this.gt());
                    }
                    break;
                case "ActualPixelScalingRatio":
                    this.uq.fv(this.gi);
                    break;
                case "WindowRectMinWidth":
                case "WindowRectMinHeight":
                    let h = d;
                    if (isNaN_(h) || isInfinity(h)) {
                        this.gm = 5E-06;
                        this.gl = 5E-06;
                    }
                    else {
                        this.gm = h;
                        this.gl = h;
                    }
                    break;
                case XamGeographicMap.$$p[7]:
                    this.ps();
                    break;
                case "MarkerAutomaticBehavior":
                    for (let i of fromEnum(this.series)) {
                        i.oh();
                    }
                    break;
            }
        }
        vm(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new ImageTilesReadyEventArgs());
            }
        }
        vr(a) {
            if (a != null) {
                a.bi = null;
            }
        }
        vs() {
            if (this.ue != null) {
                this.ue.l5 = this.wf.left;
                this.ue.l4 = this.wf.right;
            }
            if (this.ug != null) {
                this.ug.l5 = this.wf.top;
                this.ug.l4 = this.wf.bottom;
            }
            this.ue.c2(true);
            this.ug.c2(true);
        }
        getFontInfo() {
            this.ur = this.uq.fo;
            return this.ur;
        }
        sw() {
            return this.uq.fw;
        }
        getFontBrush() {
            return this.uq.fx;
        }
        pd(a, b) {
            if (typeCast(ItfConverter.$, b) !== null) {
                let c = b;
                let d = a;
                d.itemsSource = c.triangulationSource.points;
                d.ue = c.triangulationSource.triangles;
            }
            else {
                super.pd(a, b);
            }
        }
        register(a, b) {
            this.o3(a, b);
        }
        unRegister(a) {
            this.pj(a);
        }
        deferredRefresh() {
            this.l2();
        }
        deferAction(a) {
            if (this.u3 != null) {
                this.u3.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        vj(a) {
            this.pr(a);
        }
        u4() {
            let a = new ChartVisualData();
            let b = this.ue.fw();
            let c = this.ug.fw();
            a.axes.add1(b);
            a.axes.add1(c);
            for (let d = 0; d < this.series.count; d++) {
                let e = this.series._inner[d].jr();
                a.series.add1(e);
            }
            a.name = this.name;
            a.contentArea = RectData.b(this.t6);
            a.centralArea = RectData.b(this.t6);
            a.plotArea = RectData.b(this.t6);
            return a;
        }
        ty(a, b, c) {
            return a;
        }
        vn() {
        }
        get wq() {
            return this.wc;
        }
        set wq(a) {
            this.wc = a;
        }
        vx(a) {
            this.wq = a;
            this.vw();
        }
        vw() {
            if (this.ux && !this.wq.isEmpty) {
                let a = this.getZoomFromGeographicRect(this.wq);
                this.wq = Rect.empty;
                this.py(a, false);
            }
        }
        get ux() {
            return !this.t6.isEmpty && !this.tv.isEmpty;
        }
    }
    XamGeographicMap.$t = /*@__PURE__*/ markType(XamGeographicMap, 'XamGeographicMap', SeriesViewer.$, [IMapRenderDeferralHandler_$type]);
    XamGeographicMap.uo = 0;
    XamGeographicMap.wb = /*@__PURE__*/ new Rect(2, { $type: Point_$type, x: -180, y: -85.05112878 }, { $type: Point_$type, x: 180, y: 85.05112878 });
    XamGeographicMap.we = /*@__PURE__*/ new Rect(0, 0, 0, 1, 1);
    XamGeographicMap.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, XamGeographicMap, 'op', ['BackgroundTilingMode:ul:vy', [MapBackgroundTilingMode_$type, /*@__PURE__*/ enumGetBox(MapBackgroundTilingMode_$type, 0)], 'IsHorizontalWrappingEnabled:ut:vz', [0, false], 'ResizeBehavior:up:v0', [MapResizeBehavior_$type, /*@__PURE__*/ enumGetBox(MapResizeBehavior_$type, XamGeographicMap.uo)], 'SuppressZoomResetOnWorldRectChange:uu:v1', [0, false], 'UseWorldRectForZoomBounds:uv:v2', [0, false], 'WindowScale:u1:v3', [1, NaN], 'WorldRect:wr:v4', [Rect.$, XamGeographicMap.wb], 'Zoomable:uw:v5', [0, true]]);
    return XamGeographicMap;
})();
/**
 * @hidden
 */
export let GeographicMapImagery = /*@__PURE__*/ (() => {
    class GeographicMapImagery extends Control {
        constructor(a) {
            super();
            this.ak = null;
            this.imageTilesReady = null;
            this.an = null;
            this.ap = null;
            this.propertyChanged = null;
            this.imagesChanged = null;
            this.cancellingImage = null;
            this.downloadingImage = null;
            this.ab = GeographicMapImagery.$;
            this.ap = a;
            this.aj = this.ai();
            this.bb(this.aj);
        }
        bb(a) {
        }
        ai() {
            return new GeographicMapImageryView(this);
        }
        get deferralHandler() {
            return this.ak;
        }
        set deferralHandler(a) {
            this.ak = a;
            if (this.ao != null) {
                this.ao.al = a;
            }
        }
        a5(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new ImageTilesReadyEventArgs());
            }
        }
        a9() {
            let a = this.ao;
            a.imageTilesReady = delegateCombine(a.imageTilesReady, runOn(this, this.a5));
            this.ao.al = this.deferralHandler;
            let b = this.ao;
            b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.a4));
            let c = this.ao;
            c.downloadingImage = delegateCombine(c.downloadingImage, runOn(this, this.a3));
            let d = this.ao;
            d.cancellingImage = delegateCombine(d.cancellingImage, runOn(this, this.a2));
            this.ao.bf = this.referer;
            this.ao.bj = this.userAgent;
            this.ao.av = this.isHorizontalWrappingEnabled;
        }
        a3(a, b) {
            if (this.downloadingImage != null) {
                this.downloadingImage(this, b);
            }
        }
        a2(a, b) {
            if (this.cancellingImage != null) {
                this.cancellingImage(this, b);
            }
        }
        bg() {
            if (this.ao != null) {
                this.aj.e();
            }
        }
        ba(a, b, c) {
            switch (a) {
                case GeographicMapImagery.$$p[3]:
                    this.bg();
                    break;
                case "GeographicMap":
                    this.aj.e();
                    break;
                case GeographicMapImagery.$$p[1]:
                    if (this.ao != null) {
                        this.ao.bf = this.referer;
                    }
                    break;
                case GeographicMapImagery.$$p[2]:
                    if (this.ao != null) {
                        this.ao.bj = this.userAgent;
                    }
                    break;
                case GeographicMapImagery.$$p[0]:
                    if (this.ao != null) {
                        this.ao.av = this.isHorizontalWrappingEnabled;
                    }
                    break;
            }
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        get geographicMap() {
            return this.c(GeographicMapImagery.geographicMapProperty);
        }
        set geographicMap(a) {
            this.h(GeographicMapImagery.geographicMapProperty, a);
        }
        static a8(a, b) {
            a.a7(b.oldValue, b.newValue);
        }
        a7(a, b) {
            this.ba("GeographicMap", a, b);
        }
        clearTileCache() {
            if (this.ao != null) {
                this.ao.bs(0, 0, 0, 0);
            }
        }
        get ao() {
            return this.an;
        }
        set ao(a) {
            this.an = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("MultiScaleImage"));
            }
        }
        bn(a) {
            if (this.geographicMap == null || a.width < 1 || a.height < 1) {
                return a;
            }
            let b = new Rect(0, 0, 0, a.width, a.height);
            let c = this.geographicMap.wk(b);
            let d = XamGeographicMap.wb;
            let e = this.geographicMap.wf;
            let f = Math.min(this.windowRect.height, this.windowRect.width);
            let g = e.width / d.width;
            this.ao.a5 = (b.width / c.width) * f * g;
            let h = this.geographicMap.ue;
            let i = this.geographicMap.ug;
            let j = new ScalerParams(1, this.windowRect, b, h.ch);
            j.c = c;
            let k = new ScalerParams(1, this.windowRect, b, i.ch);
            k.c = c;
            let l = h.ej(d.left, j);
            let m = i.ej(d.bottom, k);
            let n = (-l / b.width) * this.ao.a5;
            let o = (-m / b.height) * this.ao.a5 * (b.height / b.width);
            this.ao.cm = { $type: Point_$type, x: n, y: o };
            return a;
        }
        bd(a) {
            this.aj.f(a);
        }
        bf(a) {
            this.aj.h(a);
        }
        be(a) {
            this.aj.g(a);
        }
        a4(a, b) {
            if (this.imagesChanged != null) {
                this.imagesChanged(this, new ImagesChangedEventArgs());
            }
        }
        a6() {
            this.aj.e();
        }
        bc(a) {
            this.aj.i(a);
        }
        v() {
            super.v();
            this.ap.o = this._opacity;
        }
    }
    GeographicMapImagery.$t = /*@__PURE__*/ markType(GeographicMapImagery, 'GeographicMapImagery', Control.$, [INotifyPropertyChanged_$type]);
    GeographicMapImagery.geographicMapProperty = /*@__PURE__*/ DependencyProperty.i("GeographicMap", XamGeographicMap.$, GeographicMapImagery.$, /*@__PURE__*/ new PropertyMetadata(2, null, GeographicMapImagery.a8));
    GeographicMapImagery.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicMapImagery, 'ba', ['IsHorizontalWrappingEnabled', [0, false], 'Referer', [2, null], 'UserAgent', [2, null], 'WindowRect', [Rect.$, Rect.empty]]);
    return GeographicMapImagery;
})();
/**
 * @hidden
 */
export let GeographicMapImageryView = /*@__PURE__*/ (() => {
    class GeographicMapImageryView extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.j = null;
            this.d = null;
            this.b = 1;
            this.j = Rect.empty;
            this.a = a;
            this.a.ao = new XamMultiScaleImage();
            this.a.ao.ao = this.a.ap;
            this.a.a9();
        }
        e() {
            if (this.j.isEmpty) {
                return;
            }
            this.a.bn(new Size(1, this.j.width, this.j.height));
        }
        f(a) {
            this.a.ao.b1(a);
        }
        g(a) {
            this.d = a;
            this.a.ao.b2(a);
        }
        h(a) {
            this.j = a;
            this.a.ao.b3(a);
            this.a.a6();
        }
        get c() {
            return this.b;
        }
        i(a) {
            this.b = a;
            this.a.ao.bz(a);
        }
    }
    GeographicMapImageryView.$t = /*@__PURE__*/ markType(GeographicMapImageryView, 'GeographicMapImageryView');
    return GeographicMapImageryView;
})();
/**
 * @hidden
 */
export let GeographicXYTriangulatingSeriesView = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.ch = null;
            this.ch = a;
        }
        b5() {
            super.b5();
            let a = this.ch.t5;
            a.u5 = this.ch.uh;
            a.vd = this.ch.uf;
            a.trianglesSource = this.ch.ue;
            a.ut = this.ch.uk;
            a.uv = this.ch.um;
            a.ux = this.ch.uo;
        }
        ck() {
            let a = this.ch.t5;
            if (this.ch.cv == null) {
                a.t3 = null;
                a.t4 = null;
                return;
            }
            a.t3 = this.ch.cv.ue;
            a.t4 = this.ch.cv.ug;
        }
        cj() {
            this.ch.t5.u5 = this.ch.uh;
        }
        ci() {
            this.ch.t5.vd = this.ch.uf;
        }
        cl() {
            this.ch.t5.trianglesSource = this.ch.ue;
        }
        cm() {
            this.ch.t5.ut = this.ch.uk;
        }
        cn() {
            this.ch.t5.uv = this.ch.um;
        }
        co() {
            this.ch.t5.ux = this.ch.uo;
        }
    }
    GeographicXYTriangulatingSeriesView.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesView, 'GeographicXYTriangulatingSeriesView', HostSeriesView.$);
    return GeographicXYTriangulatingSeriesView;
})();
/**
 * @hidden
 */
export let GeographicScatterAreaSeriesView = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesView extends GeographicXYTriangulatingSeriesView {
        constructor(a) {
            super(a);
            this.cp = null;
            this.cp = a;
        }
        au() {
            super.au();
            if (!this.q) {
            }
        }
        b5() {
            super.b5();
            if (this.cp.uz != null) {
                this.cp.uz.wc = this.cp.u3;
                this.cp.uz.v0 = this.cp.uy;
            }
        }
        cq() {
            if (this.cp.uz != null) {
                this.cp.uz.wc = this.cp.u3;
            }
        }
        cr() {
            if (this.cp.uz != null) {
                this.cp.uz.v0 = this.cp.uy;
            }
        }
    }
    GeographicScatterAreaSeriesView.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesView, 'GeographicScatterAreaSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicScatterAreaSeriesView;
})();
/**
 * @hidden
 */
export let XamGeographicMapView = /*@__PURE__*/ (() => {
    class XamGeographicMapView extends SeriesViewerView {
        constructor(a) {
            super(a);
            this.fn = null;
            this.fz = null;
            this.fx = null;
            this.fw = null;
            this.fo = null;
            this.fp = NaN;
            this.fz = Rect.empty;
            this.fn = a;
            this.fn.sr = 2;
            this.fn.hr = 5E-06;
        }
        m(a) {
            return 2;
        }
        bk(a) {
            this.j.bw(a);
            this.fn.vj(a);
            this.el();
        }
        get_ap() {
            return true;
        }
        d4() {
            let a;
            let b;
            let c;
            let d;
            let e;
            let f = this.j.a8(a, b, c, d, e);
            a = f.p0;
            b = f.p1;
            c = f.p2;
            d = f.p3;
            e = f.p4;
            this.fx = c;
            this.fo = d;
            this.fw = e;
            let g = this.j.e();
            this.fn.ag = g.a;
            this.fn.aj = g.f;
            this.fn.ah = g.b != null ? g.b : new BrushCollection();
            this.fn.ai = g.c != null ? g.c : new BrushCollection();
            if (this.fn.ah.count == 0) {
                for (let h = 0; h < g.a.count; h++) {
                    this.fn.ah.add(g.a.item(h));
                }
            }
            if (g.c.count == 0) {
                for (let i = 0; i < g.f.count; i++) {
                    this.fn.ai.add(g.f.item(i));
                }
            }
        }
        du(a) {
            super.du(a);
            if (this.fn.backgroundContent != null) {
                let b = this.fn.backgroundContent;
                b.be(this.j.ae);
                b.bd(a);
            }
        }
        dv(a) {
            super.dv(a);
            this.fz = a;
            if (this.fn.backgroundContent != null) {
                let b = this.fn.backgroundContent;
                b.bf(this.fz);
            }
        }
        fy() {
            return new Rect(0, 0, 0, this.fz.width, this.fz.height);
        }
        fs() {
            if (this.fn.backgroundContent != null) {
                let a = this.fn.backgroundContent;
                a.a6();
            }
        }
        fr(a) {
            if (this.fn.uj != null) {
                this.fn.uj.windowRect = a;
            }
        }
        fu(a, b) {
            if (this.fn.uj != null) {
                this.fn.uj.windowRect = this.fn.tr;
            }
            if (a != null) {
                let c = a.ao;
                if (c != null) {
                    this.fn.al.h.remove(c.ag);
                }
                a.bd(null);
                a.be(null);
            }
            if (b != null) {
                let d = b.ao;
                if (d != null) {
                    this.fn.al.h.add(d.ag);
                }
                if (!this.fz.isEmpty) {
                    this.dv(this.fz);
                }
                if (this.w != null) {
                    this.du(this.w);
                }
            }
            if (b == null) {
                this.ft(this.w);
            }
        }
        ft(a) {
            let b = this.fn.gi;
            if (b != 1) {
                a.aa();
                a.ab(b, b);
            }
            a.l(this.fz.left, this.fz.top, this.fz.width, this.fz.height);
            if (b != 1) {
                a.z();
            }
        }
        d1() {
            this.fd.ad = Defaults.j;
            this.fe.ad = Defaults.j;
            this.fd._stroke = Defaults.ae;
            this.fe._stroke = Defaults.ae;
            super.d1();
        }
        fv(a) {
            this.fp = a;
            if (this.fn.backgroundContent != null) {
                this.fn.backgroundContent.bc(a);
            }
        }
        get fq() {
            return this.fp;
        }
        set fq(a) {
            this.fp = a;
        }
    }
    XamGeographicMapView.$t = /*@__PURE__*/ markType(XamGeographicMapView, 'XamGeographicMapView', SeriesViewerView.$);
    return XamGeographicMapView;
})();
/**
 * @hidden
 */
export let OpenStreetMapImagery = /*@__PURE__*/ (() => {
    class OpenStreetMapImagery extends GeographicMapImagery {
        constructor() {
            super(new OpenStreetMapTileSource());
        }
        get tilePath() {
            return this.c(OpenStreetMapImagery.tilePathProperty);
        }
        set tilePath(a) {
            this.h(OpenStreetMapImagery.tilePathProperty, a);
        }
        static br(a, b) {
            a.bq("TilePath", b.oldValue, b.newValue);
        }
        bq(a, b, c) {
            switch (a) {
                case "TilePath":
                    this.ap.setTilePathUrl(c == null ? null : c);
                    this.aj.e();
                    break;
            }
            super.ba(a, b, c);
        }
    }
    OpenStreetMapImagery.$t = /*@__PURE__*/ markType(OpenStreetMapImagery, 'OpenStreetMapImagery', GeographicMapImagery.$);
    OpenStreetMapImagery.tilePathProperty = /*@__PURE__*/ DependencyProperty.i("TilePath", String_$type, OpenStreetMapImagery.$, /*@__PURE__*/ new PropertyMetadata(2, null, OpenStreetMapImagery.br));
    return OpenStreetMapImagery;
})();
/**
 * @hidden
 */
export let GeographicXYTriangulatingSeries = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeries extends GeographicMapSeriesHost {
        cd() {
            return new GeographicXYTriangulatingSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.ud = a;
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.ud.ck();
                    break;
                case GeographicXYTriangulatingSeries.$$p[1]:
                    this.ud.cj();
                    break;
                case GeographicXYTriangulatingSeries.$$p[0]:
                    this.ud.ci();
                    break;
                case GeographicXYTriangulatingSeries.$$p[5]:
                    this.ud.cl();
                    break;
                case GeographicXYTriangulatingSeries.$$p[2]:
                    this.ud.cm();
                    break;
                case GeographicXYTriangulatingSeries.$$p[3]:
                    this.ud.cn();
                    break;
                case GeographicXYTriangulatingSeries.$$p[4]:
                    this.ud.co();
                    break;
            }
        }
    }
    GeographicXYTriangulatingSeries.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeries, 'GeographicXYTriangulatingSeries', GeographicMapSeriesHost.$);
    GeographicXYTriangulatingSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicXYTriangulatingSeries, 'raisePropertyChanged', ['LatitudeMemberPath:uf:uq', [2, "pointY"], 'LongitudeMemberPath:uh:ur', [2, "pointX"], 'TriangleVertexMemberPath1:uk:ut', [2, "v1"], 'TriangleVertexMemberPath2:um:uu', [2, "v2"], 'TriangleVertexMemberPath3:uo:uv', [2, "v3"], 'TrianglesSource:ue:us', [IEnumerable_$type, null]]);
    return GeographicXYTriangulatingSeries;
})();
/**
 * @hidden
 */
export let GeographicScatterAreaSeries = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeries extends GeographicXYTriangulatingSeries {
        bc() {
            return new GeographicScatterAreaSeries();
        }
        get_d9() {
            return true;
        }
        constructor() {
            super();
            this.uw = null;
            this.triangulationStatusChanged = null;
            this.ab = GeographicScatterAreaSeries.$;
        }
        get uy() {
            return this.uw;
        }
        set uy(a) {
            let b = this.uw != a;
            if (b) {
                let c = this.uw;
                if (this.uw != null) {
                    let d = this.uw;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.u6));
                }
                this.uw = a;
                if (this.uw != null) {
                    let e = this.uw;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.u6));
                }
                this.raisePropertyChanged("ColorScale", c, this.uw);
                if (this.uz != null) {
                    this.uz.v0 = a;
                }
            }
        }
        u6(a, b) {
            this.u1.cr();
            this.u8();
            this.pr(false);
        }
        u8() {
            if (this.uz != null) {
                this.ux = this.uz.vz;
            }
        }
        qf() {
            super.qf();
            this.u8();
        }
        t4() {
            this.uz = new ScatterAreaSeries();
            let a = this.uz;
            a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.u7));
            return this.uz;
        }
        u7(a, b) {
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, b);
            }
        }
        cd() {
            return new GeographicScatterAreaSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.u1 = a;
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case GeographicScatterAreaSeries.$$p[1]:
                    this.u1.cq();
                    break;
                case "ColorScale":
                    this.u1.cr();
                    this.u8();
                    break;
            }
        }
        get_gg() {
            return true;
        }
        set_gg(a) {
            super.set_gg(a);
        }
    }
    GeographicScatterAreaSeries.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeries, 'GeographicScatterAreaSeries', GeographicXYTriangulatingSeries.$);
    GeographicScatterAreaSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:ux:u9', [ColorScale.$, null], 'ColorMemberPath:u3:va', [2, "value"]]);
    return GeographicScatterAreaSeries;
})();
