import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { IgcGetTileImageUriArgs } from "igniteui-webcomponents-core";
import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
/**
 * Represents a CustomMapImagery MapImagery
*/
export class IgcCustomMapImagery extends IgcGeographicMapImagery {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
        this._getTileImageUri = null;
        this._getTileImageUri_wrapped = null;
    }
    /**
     * Raised when URI for tiles should be provided
    */
    get getTileImageUri() {
        return this._getTileImageUri;
    }
    set getTileImageUri(ev) {
        if (this._getTileImageUri_wrapped !== null) {
            this.i.getTileImageUri = delegateRemove(this.i.getTileImageUri, this._getTileImageUri_wrapped);
            this._getTileImageUri_wrapped = null;
            this._getTileImageUri = null;
        }
        this._getTileImageUri = ev;
        this._getTileImageUri_wrapped = (o, e) => {
            let outerArgs = new IgcGetTileImageUriArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeGetTileImageUri) {
                this.beforeGetTileImageUri(this, outerArgs);
            }
            if (this._getTileImageUri) {
                this._getTileImageUri(this, outerArgs);
            }
        };
        this.i.getTileImageUri = delegateCombine(this.i.getTileImageUri, this._getTileImageUri_wrapped);
        ;
    }
}
