/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IgcSeriesComponent } from "igniteui-webcomponents-charts";
import { IgcSeriesViewerComponent } from "igniteui-webcomponents-charts";
import { WebComponentRenderer, WebComponentWrapper } from "igniteui-webcomponents-core";
import { TypeRegistrar, delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { XamGeographicMap } from './XamGeographicMap';
import { CollectionAdapter, toPoint, fromPoint, toRect, fromRect, ensureBool, ensureEnum, NamePatcher, enumToString, rectToString, toSpinal } from "igniteui-webcomponents-core";
import { DataChartStylingDefaults } from "igniteui-webcomponents-charts";
import { IgcDataContext } from "igniteui-webcomponents-core";
import { IgcSeriesCollection } from "igniteui-webcomponents-charts";
import { NotifyCollectionChangedAction } from "igniteui-webcomponents-core";
import { getAllPropertyNames } from "igniteui-webcomponents-core";
import { IgcNumericXAxisComponent } from "igniteui-webcomponents-charts";
import { IgcNumericYAxisComponent } from "igniteui-webcomponents-charts";
import { IgcImageTilesReadyEventArgs } from './igc-image-tiles-ready-event-args';
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { MapResizeBehavior_$type } from './MapResizeBehavior';
import { MapBackgroundTilingMode_$type } from './MapBackgroundTilingMode';
export let IgcGeographicMapComponent = /*@__PURE__*/ (() => {
    class IgcGeographicMapComponent extends IgcSeriesViewerComponent {
        set height(value) {
            this._height = value;
            this.style.height = value;
            this.notifyContainerResized();
        }
        get height() {
            return this._height;
        }
        set width(value) {
            this._width = value;
            this.style.width = value;
            this.notifyContainerResized();
        }
        get width() {
            return this._width;
        }
        notifyContainerResized() {
            this._chart.notifyContainerResized();
        }
        /**
         * Gets or sets the legend used for the current chart.
        */
        get legend() {
            if (this.i.legend != null)
                return this.i.legend.externalObject;
        }
        set legend(v) {
            if (v != undefined && v != null)
                this.i.legend = v.i;
        }
        /**
         * A collection or manually added series for the chart.
        */
        get series() {
            if (this._series === null) {
                let coll = new IgcSeriesCollection();
                let inner = coll._innerColl;
                inner.addListener((sender, e) => {
                    if (!this._seriesAdapter) {
                        return;
                    }
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            this._seriesAdapter.addManualItem(e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            this._seriesAdapter.clearManualItems();
                            break;
                    }
                });
                this._series = coll;
            }
            return this._series;
        }
        constructor() {
            super();
            this.contentSeries = [];
            /**
             * The series actually present in the chart. Do not directly modify this array.
             * This array's contents can be modified by causing Angular to reproject the child content.
             * Or adding and removing series from the manual series collection on the series property.
             */
            this.actualSeries = [];
            this._series = null;
            this._dataSource = null;
            this._seriesAdapter = null;
            this._disconnected = false;
            this._defaultTooltips = null;
            this._imageTilesReady = null;
            this._imageTilesReady_wrapped = null;
            if (this._styling) {
                NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._renderer = new WebComponentRenderer(this, document, true, DataChartStylingDefaults);
            //this._implementation = this.createImplementation();
            this._container = this._renderer.createElement("div");
            this._renderer.updateRoot(this._container);
            //this._renderer.rootWrapper.append(this._container);
            this._container.setStyleProperty("display", "block");
            this._container.setStyleProperty("width", "100%");
            this._container.setStyleProperty("height", "100%");
            var root;
            root = this._container;
            if (this._container.nativeElement != null) {
                root = this._container.nativeElement;
            }
            this._wrapper = this._renderer;
            var chart = this.i;
            this._chart = chart;
            this._seriesAdapter = new CollectionAdapter(this.contentSeries, this.i.series, this.actualSeries, (c) => c.i, (i) => {
                i.owner = this;
                i._provideRenderer(this._dataSource);
                i.provideData(this._dataSource);
                if (this.parentElement) {
                    i._styling(this, this, this);
                }
                //i.bindAxes(this.axes);
                this._ensureDefaultTooltip(i);
                this._ensureTooltipCreated(i);
            }, (i) => { i._provideRenderer(null); i.provideData(null); });
            chart.provideContainer(this._renderer);
            let mut = new MutationObserver((list) => {
                for (var mutation of list) {
                    if (mutation.type == 'childList') {
                        this.updateContentChildren();
                    }
                }
            });
            mut.observe(this, {
                childList: true
            });
            this._renderer.addSizeWatcher(() => {
                this.notifyContainerResized();
            });
        }
        destroy() {
            this._chart.destroy();
            this._wrapper.destroy();
        }
        createImplementation() {
            return new XamGeographicMap();
        }
        set dataSource(value) {
            this._dataSource = value;
            this.bindData();
        }
        get dataSource() {
            return this._dataSource;
        }
        bindData() {
            if (this.actualSeries && this.actualSeries.length > 0) {
                var currSeries = this.actualSeries;
                for (var i = 0; i < currSeries.length; i++) {
                    currSeries[i].provideData(this._dataSource);
                }
            }
        }
        updateContentChildren() {
            this.contentSeries.length = 0;
            for (var i = 0; i < this.children.length; i++) {
                if (this.children[i] instanceof IgcSeriesComponent) {
                    this.contentSeries.push(this.children[i]);
                }
            }
            if (this._seriesAdapter != null) {
                this._seriesAdapter.notifyContentChanged();
            }
        }
        disconnectedCallback() {
            this._disconnected = true;
            if (this.i) {
                this.i.onDetachedFromUI();
            }
        }
        connectedCallback() {
            if (this._disconnected) {
                this._disconnected = false;
                if (this.i) {
                    this.i.onAttachedToUI();
                }
                return;
            }
            this.classList.add("igc-geographic-map");
            this.classList.add("ig-geographic-map");
            this.appendChild(this._renderer.rootWrapper.getNativeElement());
            this._attached = true;
            this.style.display = "block";
            this.style.height = this._height;
            this.style.width = this._width;
            this._flushQueuedAttributes();
            // supports themes or custom properties set in CSS 
            this._styling(this, this);
            for (let i = 0; i < this.actualSeries.length; i++) {
                let s = this.actualSeries[i];
                s._styling(this, this, this);
            }
            this.updateContentChildren();
            this.afterContentInit();
        }
        afterContentInit() {
            if (TypeRegistrar.isRegistered("IgcDataChartDefaultTooltipsComponent")) {
                let cr = TypeRegistrar.create("IgcDataChartDefaultTooltipsComponent");
                //let cr = cf.create(this._injector);
                this._defaultTooltips = cr;
                cr.onContentReady = () => {
                    this._onDefaultTooltipsReady(cr);
                };
                //this._container.appendChild(cr.location.nativeElement);
            }
            this.i.notifyContainerResized();
        }
        _ensureTooltipCreated(series) {
            series._ensureTooltipCreated(() => this.createTooltip(), (ele) => {
                let wrapper = new WebComponentWrapper(ele, this._renderer);
                wrapper.updateToolTip = ele.updateToolTip;
                wrapper.hideToolTip = ele.hideToolTip;
                return wrapper;
            });
        }
        _ensureDefaultTooltip(series) {
            if (this._defaultTooltips == null) {
                return;
            }
            this._defaultTooltips["ensureDefaultTooltip"](series);
        }
        _onDefaultTooltipsReady(cr) {
            if (this.actualSeries && this.actualSeries.length > 0) {
                var currSeries = this.actualSeries;
                for (var i = 0; i < currSeries.length; i++) {
                    if (currSeries[i].showDefaultTooltip) {
                        this._ensureDefaultTooltip(currSeries[i]);
                    }
                }
            }
        }
        createTooltip() {
            if (!TypeRegistrar.isRegistered("IgcTooltipContainerComponent")) {
                return null;
            }
            let cr = TypeRegistrar.create("IgcTooltipContainerComponent");
            let ele = cr;
            let self = this;
            ele.updateToolTip = function (c, isSubContent) {
                if (c.externalObject) {
                    c = c.externalObject;
                }
                else {
                    let ext = new IgcDataContext();
                    ext._implementation = c;
                    c = ext;
                }
                if (!isSubContent) {
                    if (ele.parentElement != self._container.getNativeElement()) {
                        if (ele.parentElement != null) {
                            ele.parentElement.removeChild(ele);
                        }
                        self._container.getNativeElement().appendChild(ele);
                    }
                }
                else {
                    c.isSubContent = true;
                }
                cr.context = c;
                ele.style.display = "block";
                return true;
            };
            ele.hideToolTip = function () {
                ele.style.display = "none";
            };
            ele.style.display = "none";
            return cr;
        }
        /**
         * An imagery to display behind all series, inside the viewport of the IgxGeographicMapComponent control.
        */
        get backgroundContent() {
            if (this.i.backgroundContent != null) {
                return this.i.backgroundContent.externalObject;
            }
            else {
                return null;
            }
        }
        set backgroundContent(v) {
            if (typeof (v) == "string" && v == "empty") {
                this.i.backgroundContent = null;
                this._a("backgroundContent", "empty");
                return;
            }
            if (v != undefined && v != null) {
                this.i.backgroundContent = v.i;
            }
            else {
                this.i.backgroundContent = null;
                this._a("backgroundContent", "empty");
            }
        }
        /**
                                 * @hidden
                                 */
        get i() {
            return this._implementation;
        }
        static get observedAttributes() {
            if (IgcGeographicMapComponent._observedAttributesIgcGeographicMapComponent == null) {
                let names = getAllPropertyNames(IgcGeographicMapComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGeographicMapComponent._observedAttributesIgcGeographicMapComponent = names;
            }
            return IgcGeographicMapComponent._observedAttributesIgcGeographicMapComponent;
        }
        static register() {
            if (!IgcGeographicMapComponent._isElementRegistered) {
                IgcGeographicMapComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcGeographicMapComponent.htmlTagName, IgcGeographicMapComponent);
            }
        }
        /**
     * Gets or sets zoomability of the current control
    */
        get zoomable() {
            return this.i.uw;
        }
        set zoomable(v) {
            this.i.uw = ensureBool(v);
            this._a("zoomable", this.i.uw);
        }
        /**
         * Gets or sets the behavior to use during resize.
        */
        get resizeBehavior() {
            return this.i.up;
        }
        set resizeBehavior(v) {
            this.i.up = ensureEnum(MapResizeBehavior_$type, v);
            this._a("resizeBehavior", enumToString(MapResizeBehavior_$type, this.i.up));
        }
        /**
         * Gets or sets if the map should horizontally wrap.
        */
        get isHorizontalWrappingEnabled() {
            return this.i.ut;
        }
        set isHorizontalWrappingEnabled(v) {
            this.i.ut = ensureBool(v);
            this._a("isHorizontalWrappingEnabled", this.i.ut);
        }
        /**
         * Gets or sets if the map should horizontally wrap.
        */
        get backgroundTilingMode() {
            return this.i.ul;
        }
        set backgroundTilingMode(v) {
            this.i.ul = ensureEnum(MapBackgroundTilingMode_$type, v);
            this._a("backgroundTilingMode", enumToString(MapBackgroundTilingMode_$type, this.i.ul));
        }
        /**
         * Gets or sets whether to use the uncoerced world rect to constrain the zoom bounds.
        */
        get useWorldRectForZoomBounds() {
            return this.i.uv;
        }
        set useWorldRectForZoomBounds(v) {
            this.i.uv = ensureBool(v);
            this._a("useWorldRectForZoomBounds", this.i.uv);
        }
        /**
         * Gets or sets whether skip resetting the zoom when the world rect changes.
        */
        get suppressZoomResetOnWorldRectChange() {
            return this.i.uu;
        }
        set suppressZoomResetOnWorldRectChange(v) {
            this.i.uu = ensureBool(v);
            this._a("suppressZoomResetOnWorldRectChange", this.i.uu);
        }
        /**
         * Gets or sets the world bounding rectangle.
        */
        get worldRect() {
            return fromRect(this.i.wr);
        }
        set worldRect(v) {
            this.i.wr = toRect(v);
            this._a("worldRect", rectToString(this.i.wr));
        }
        /**
         * Gets the actual value of the WorldRect.
        */
        get actualWorldRect() {
            return fromRect(this.i.wf);
        }
        set actualWorldRect(v) {
            this.i.wf = toRect(v);
            this._a("actualWorldRect", rectToString(this.i.wf));
        }
        /**
         * The X-axis for this IgxGeographicMap.Component
         * Under normal circumstances, this property should not be set in application code.  By default, it will be set to a numeric axis with a spherical mercator scaler.
        */
        get xAxis() {
            const r = this.i.ue;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                let e = IgcNumericXAxisComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        }
        set xAxis(v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.ue = null : this.i.ue = v.i;
        }
        /**
         * The Y-axis for this IgxGeographicMap.Component
         * Under normal circumstances, this property should not be set in application code.  By default, it will be set to a numeric axis with a spherical mercator scaler.
        */
        get yAxis() {
            const r = this.i.ug;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                let e = IgcNumericYAxisComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        }
        set yAxis(v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.ug = null : this.i.ug = v.i;
        }
        /**
         * Indicates if this SeriesViewer is a map.
        */
        get isMap() {
            return this.i.en;
        }
        /**
         * A number between 0 and 1 determining the scale of the horizontal/vertical zoom.
         * This property is effectively a shortcut to the Width/Height of the WindowRect property.
        */
        get windowScale() {
            return this.i.u1;
        }
        set windowScale(v) {
            this.i.u1 = +v;
            this._a("windowScale", this.i.u1);
        }
        /**
         * A number between 0 and 1 determining the scale of the horizontal/vertical zoom.
         * This property is effectively a shortcut to the Width/Height of the ActualWindowRect property.
        */
        get actualWindowScale() {
            return this.i.u0;
        }
        set actualWindowScale(v) {
            this.i.u0 = +v;
            this._a("actualWindowScale", this.i.u0);
        }
        /**
         * Gets whether or not the control is ready for zooming
        */
        get zoomIsReady() {
            return this.i.ux;
        }
        findByName(name) {
            var baseResult = super.findByName(name);
            if (baseResult) {
                return baseResult;
            }
            if (this.backgroundContent && this.backgroundContent.name && this.backgroundContent.name == name) {
                return this.backgroundContent;
            }
            return null;
        }
        _styling(container, component, parent) {
            super._styling(container, component, parent);
            this._inStyling = true;
            if (this.xAxis && this.xAxis._styling) {
                this.xAxis._styling(container, component, this);
            }
            if (this.yAxis && this.yAxis._styling) {
                this.yAxis._styling(container, component, this);
            }
            this._inStyling = false;
        }
        /**
     * Gets current world rect in geographic coordinates
    
    */
        getCurrentActualWorldRect() {
            let iv = this.i.wj();
            return fromRect(iv);
        }
        /**
         * Given the current plot area of the control and a geographic region, get the WindowRect that would encompass that geographic region.
        
        * @param geographic  * The geographic area.
        */
        getZoomRectFromGeoRect(geographic) {
            let iv = this.i.getZoomRectFromGeoRect(toRect(geographic));
            return fromRect(iv);
        }
        /**
         * Updates zoom window using window coordinates
        
        */
        updateZoomWindow(zoomWindow) {
            this.i.vv(toRect(zoomWindow));
        }
        /**
         * Updates world rect in geographic coordinates
        
        */
        updateWorldRect(worldRect) {
            this.i.vu(toRect(worldRect));
        }
        /**
         * Given the current plot area of the control and a geographic region, get the WindowRect that would encompass that geographic region.
        
        * @param geographic  * The geographic area.
        */
        getZoomFromGeographicRect(geographic) {
            let iv = this.i.getZoomFromGeographicRect(toRect(geographic));
            return fromRect(iv);
        }
        convertGeographicToZoom(geographic, extraPixelPadding) {
            let iv = this.i.wg(toRect(geographic), extraPixelPadding);
            return fromRect(iv);
        }
        getZoomFromGeographicPoints(northWest, southEast) {
            let iv = this.i.getZoomFromGeographicPoints(toPoint(northWest), toPoint(southEast));
            return fromRect(iv);
        }
        /**
         * Given a WindowRect and the current plot area, get the geographic region represented by that WindowRect.
        
        * @param windowRect  * The zoom area.
        */
        getGeographicFromZoom(windowRect) {
            let iv = this.i.wl(toRect(windowRect));
            return fromRect(iv);
        }
        /**
         * Convert a pixel-based coordinate to a geographic coordinate.
        
        * @param pixelCoordinate  * A pixel-based coordinate
        */
        getGeographicPoint(pixelCoordinate) {
            let iv = this.i.v7(toPoint(pixelCoordinate));
            return fromPoint(iv);
        }
        /**
         * Convert a geographic coordinate to a pixel-based coordinate.
        
        * @param geographicCoordinate  * A geographic coordinate
        */
        getPixelPoint(geographicCoordinate) {
            let iv = this.i.v8(toPoint(geographicCoordinate));
            return fromPoint(iv);
        }
        /**
         * Convert a geographic coordinate to a pixel-based coordinate.
        
        * @param geographicCoordinate  * A geographic coordinate
        */
        getWindowPoint(geographicCoordinate) {
            let iv = this.i.v9(toPoint(geographicCoordinate));
            return fromPoint(iv);
        }
        /**
         * Removes all cached tile images from the map imagery assigned to the map's background content.
        
        */
        clearTileCache() {
            this.i.vi();
        }
        /**
         * Notifies the chart that the CSS styles in effect have been updated.
        
        */
        styleUpdated() {
            this.i.vq();
        }
        /**
         * Gets actual window scale for horizontal dimension of the control
        
        */
        getActualWindowScaleHorizontal() {
            let iv = this.i.gs();
            return (iv);
        }
        /**
         * Gets actual window scale for vertical dimension of the control
        
        */
        getActualWindowScaleVertical() {
            let iv = this.i.gt();
            return (iv);
        }
        /**
         * Calls for a deferred refresh to the GeographicMap's background.
        
        */
        deferredRefresh() {
            this.i.deferredRefresh();
        }
        /**
         * Returns the chart visuals expressed as a ChartVisualData object.
        
        */
        exportVisualData() {
            let iv = this.i.u4();
            return (iv);
        }
        /**
         * Zoom in to the geographic region specified, when possible (may need to wait for map to be initialized).
        
        * @param geographic  * The geographic region to zoom to.
        */
        zoomToGeographic(geographic) {
            this.i.vx(toRect(geographic));
        }
        /**
         * This event is fired whenever the image tiles transition from a loading state (e.g. some are fading in) to a loaded state.
        */
        get imageTilesReady() {
            return this._imageTilesReady;
        }
        set imageTilesReady(ev) {
            if (this._imageTilesReady_wrapped !== null) {
                this.i.imageTilesReady = delegateRemove(this.i.imageTilesReady, this._imageTilesReady_wrapped);
                this._imageTilesReady_wrapped = null;
                this._imageTilesReady = null;
            }
            this._imageTilesReady = ev;
            this._imageTilesReady_wrapped = (o, e) => {
                let outerArgs = new IgcImageTilesReadyEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeImageTilesReady) {
                    this.beforeImageTilesReady(this, outerArgs);
                }
                if (this._imageTilesReady) {
                    this._imageTilesReady(this, outerArgs);
                }
            };
            this.i.imageTilesReady = delegateCombine(this.i.imageTilesReady, this._imageTilesReady_wrapped);
            ;
        }
    }
    IgcGeographicMapComponent._observedAttributesIgcGeographicMapComponent = null;
    IgcGeographicMapComponent.htmlTagName = "igc-geographic-map";
    IgcGeographicMapComponent._isElementRegistered = false;
    return IgcGeographicMapComponent;
})();
