/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { SeriesViewer } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { MapResizeBehavior_$type } from "./MapResizeBehavior";
import { MapBackgroundTilingMode_$type } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-webcomponents-core";
import { Base, Boolean_$type, typeCast, enumGetBox, Point_$type, fromEnum, Number_$type, runOn, delegateRemove, delegateCombine, markType, markDep, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, IEnumerable_$type } from "igniteui-webcomponents-core";
import { NumericXAxis } from "igniteui-webcomponents-charts";
import { NumericYAxis } from "igniteui-webcomponents-charts";
import { SphericalMercatorVerticalScaler } from "./SphericalMercatorVerticalScaler";
import { Control } from "igniteui-webcomponents-core";
import { SphericalMercatorHorizontalScaler } from "./SphericalMercatorHorizontalScaler";
import { ScalerParams } from "igniteui-webcomponents-charts";
import { SeriesViewerView } from "igniteui-webcomponents-charts";
import { Tuple$2 } from "igniteui-webcomponents-core";
import { MathUtil } from "igniteui-webcomponents-core";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { ItfConverter } from "igniteui-webcomponents-core";
import { ChartVisualData } from "igniteui-webcomponents-charts";
import { RectData } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-webcomponents-core";
import { XamMultiScaleImage } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ScatterAreaSeries } from "igniteui-webcomponents-charts";
import { BrushCollection } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { OpenStreetMapTileSource } from "igniteui-webcomponents-core";
import { ColorScale } from "igniteui-webcomponents-charts";
/**
 * @hidden
 */
var XamGeographicMap = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamGeographicMap, _super);
    function XamGeographicMap() {
        var _this = _super.call(this) || this;
        _this.u3 = null;
        _this.us = false;
        _this.uk = 1;
        _this.uz = 0;
        _this.wa = null;
        _this.uh = null;
        _this.ud = null;
        _this.uf = null;
        _this.uj = null;
        _this.v6 = { $type: Point_$type, x: NaN, y: NaN };
        _this.wd = null;
        _this.uy = 1;
        _this.imageTilesReady = null;
        _this.ur = null;
        _this.wc = Rect.empty;
        _this.uz = SphericalMercatorVerticalScaler.am(XamGeographicMap.wb.bottom) - SphericalMercatorVerticalScaler.am(XamGeographicMap.wb.top);
        _this.ab = XamGeographicMap.$;
        _this.backgroundContent = new OpenStreetMapImagery();
        var a = ((function () {
            var $ret = new NumericXAxis();
            $ret.bi = _this;
            return $ret;
        })());
        a.cf = true;
        _this.ue = a;
        _this.ue.nl = new SphericalMercatorHorizontalScaler();
        var b = ((function () {
            var $ret = new NumericYAxis();
            $ret.bi = _this;
            return $ret;
        })());
        b.cf = true;
        _this.ug = b;
        _this.ug.nl = new SphericalMercatorVerticalScaler();
        _this.vl();
        _this.vs();
        _this.me();
        return _this;
    }
    XamGeographicMap.prototype.provideContainer = function (a) {
        _super.prototype.provideContainer.call(this, a);
        this.ue.provideRenderer(a);
        this.ug.provideRenderer(a);
    };
    XamGeographicMap.prototype.me = function () {
        _super.prototype.me.call(this);
        this.uq.fv(this.gi);
    };
    XamGeographicMap.prototype.ev = function () {
        return this.uw;
    };
    XamGeographicMap.prototype.ew = function () {
        return this.uw;
    };
    XamGeographicMap.prototype.un = function () {
        if (this.ul == 0) {
            if (this.us) {
                return 2;
            }
        }
        return 1;
    };
    Object.defineProperty(XamGeographicMap.prototype, "um", {
        get: function () {
            return this.uk;
        },
        set: function (a) {
            this.uk = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "wf", {
        get: function () {
            return this.wa;
        },
        set: function (a) {
            var b = Rect.l_op_Inequality(this.wa, a);
            if (b) {
                var c = this.wa;
                this.wa = a;
                this.op("ActualWorldRect", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.wj = function () {
        return this.wf;
    };
    XamGeographicMap.prototype.vl = function () {
        if (this.wr.isEmpty) {
            return;
        }
        this.wf = this.wp(this.wr, this.cd == 1);
    };
    XamGeographicMap.prototype.wp = function (a, b) {
        var c = a.top;
        var d = a.left;
        var e = a.width;
        var f = a.height;
        var g = SphericalMercatorVerticalScaler.am(a.bottom);
        var h = SphericalMercatorVerticalScaler.am(a.top);
        var i = g - h;
        var j = a.width / XamGeographicMap.wb.width;
        var k = SphericalMercatorVerticalScaler.am(XamGeographicMap.wb.top);
        var l = i / j;
        if (i / j > this.uz) {
            var m = i / this.uz;
            var n = m - j;
            d = d - (n / 2) * XamGeographicMap.wb.width;
            e = m * XamGeographicMap.wb.width;
            if (b) {
                if (d < XamGeographicMap.wb.left) {
                    d += (XamGeographicMap.wb.left - d);
                }
                else if ((d + e) > XamGeographicMap.wb.right) {
                    d -= ((d + e) - XamGeographicMap.wb.right);
                }
            }
        }
        else if (i / j < this.uz) {
            var o = this.uz * j;
            var p = o - i;
            var q = h - (p / 2);
            var r = g + (p / 2);
            if (b) {
                if (q < k) {
                    q += (k - q);
                    r += (k - q);
                }
                else if (r > (k + this.uz)) {
                    q -= ((r) - (k + this.uz));
                    r -= ((r) - (k + this.uz));
                }
            }
            c = SphericalMercatorVerticalScaler.aq(q);
            f = SphericalMercatorVerticalScaler.aq(r) - c;
        }
        var s = new Rect(0, d, c, e, f);
        return s;
    };
    Object.defineProperty(XamGeographicMap.prototype, "backgroundContent", {
        get: function () {
            return this.uh;
        },
        set: function (a) {
            var b = a != this.backgroundContent;
            if (b) {
                var c = this.backgroundContent;
                this.uh = a;
                this.op("BackgroundContent", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "ue", {
        get: function () {
            return this.ud;
        },
        set: function (a) {
            var b = a != this.ue;
            if (b) {
                var c = this.ue;
                this.ud = a;
                this.op("XAxis", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "ug", {
        get: function () {
            return this.uf;
        },
        set: function (a) {
            var b = a != this.ug;
            if (b) {
                var c = this.ug;
                this.uf = a;
                this.op("YAxis", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.getZoomRectFromGeoRect = function (a) {
        return this.getZoomFromGeographicRect(a);
    };
    XamGeographicMap.prototype.vv = function (a) {
        this.t7 = a;
    };
    XamGeographicMap.prototype.vu = function (a) {
        this.wr = a;
    };
    XamGeographicMap.prototype.getZoomFromGeographicRect = function (a) {
        return this.wh(a, true, 0);
    };
    XamGeographicMap.prototype.wg = function (a, b) {
        return this.wh(a, false, b);
    };
    XamGeographicMap.prototype.wh = function (a, b, c) {
        var d = a;
        if (b) {
            d = this.wp(a, false);
        }
        var e = this.ue;
        var f = this.ug;
        var g = new ScalerParams(1, XamGeographicMap.we, this.t6, e.ch);
        g.c = this.tv;
        var h = new ScalerParams(1, XamGeographicMap.we, this.t6, f.ch);
        h.c = this.tv;
        var i = this.ue.ej(d.left, g);
        var j = this.ue.ej(d.right, g);
        var k = this.ug.ej(d.top, h);
        var l = this.ug.ej(d.bottom, h);
        var m = (i - c) / this.t6.width;
        var n = (l - c) / this.t6.height;
        var o = (j - i + (c * 2)) / this.t6.width;
        var p = (k - l + (c * 2)) / this.t6.height;
        var q = new Rect(0, m, n, o, p);
        q.intersect(XamGeographicMap.we);
        if (q.isEmpty) {
            q = XamGeographicMap.we;
        }
        return q;
    };
    XamGeographicMap.prototype.getZoomFromGeographicPoints = function (a, b) {
        var c = a.x;
        var d = b.y;
        var e = b.x - a.x;
        var f = a.y - b.y;
        if (e < 0 || f < 0) {
            return XamGeographicMap.we;
        }
        else {
            var g = new Rect(0, c, d, e, f);
            return this.getZoomFromGeographicRect(g);
        }
    };
    XamGeographicMap.prototype.wl = function (a) {
        var b = this.ue;
        var c = this.ug;
        var d = new ScalerParams(1, a, this.t6, b.ch);
        d.c = this.tv;
        var e = new ScalerParams(1, a, this.t6, c.ch);
        e.c = this.tv;
        var f = this.tu;
        var g = b.em(f.left, d);
        var h = c.em(f.top, e);
        var i = b.em(f.right, d);
        var j = c.em(f.bottom, e);
        var k = i - g;
        var l = h - j;
        var m = new Rect(0, g, j, k, l);
        if (this.cd == 1) {
            m.intersect(XamGeographicMap.wb);
            if (m.isEmpty) {
                m = XamGeographicMap.wb;
            }
        }
        return m;
    };
    XamGeographicMap.prototype.v7 = function (a) {
        var b = this.ue.l8(a.x);
        var c = this.ug.l8(a.y);
        return { $type: Point_$type, x: b, y: c };
    };
    XamGeographicMap.prototype.v8 = function (a) {
        var b = this.ue.e4(a.x);
        var c = this.ug.e4(a.y);
        return { $type: Point_$type, x: b, y: c };
    };
    XamGeographicMap.prototype.v9 = function (a) {
        return this.v8(a);
    };
    XamGeographicMap.prototype.vi = function () {
        var a = typeCast(GeographicMapImagery.$, this.backgroundContent);
        if (a != null) {
            a.clearTileCache();
        }
    };
    XamGeographicMap.prototype.vo = function (a) {
    };
    XamGeographicMap.prototype.fk = function () {
        return true;
    };
    XamGeographicMap.prototype.vq = function () {
        var e_1, _a;
        this.uq.ee();
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.qa();
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    XamGeographicMap.prototype.vt = function () {
        if (this.up == 2) {
            if (!this.t6.isEmpty && this.t6.width > 0 && this.t6.height > 0) {
                var a = this.ue.l8(this.t6.left + (this.t6.width / 2));
                var b = this.ug.l8(this.t6.top + (this.t6.height / 2));
                this.v6 = { $type: Point_$type, x: a, y: b };
            }
        }
        else {
            if (!this.t6.isEmpty && this.t6.width > 0 && this.t6.height > 0) {
                var c = this.ue.l8(this.t6.left);
                var d = this.ug.l8(this.t6.top);
                this.v6 = { $type: Point_$type, x: c, y: d };
            }
        }
    };
    XamGeographicMap.prototype.vp = function () {
        if (isNaN_(this.v6.x) || isNaN_(this.v6.y)) {
            this.vt();
        }
        var a = this.v6.x;
        var b = this.v6.y;
        if (!isNaN_(a) && !isNaN_(b)) {
            var c = this.tr.left;
            var d = this.tr.top;
            var e = this.tr.width;
            var f = this.tr.height;
            if (e > this.wd.width) {
            }
            else {
                var g = new ScalerParams(1, XamGeographicMap.we, this.t6, this.ue.ch);
                g.c = this.tv;
                var h = this.ue.ej(a, g);
                if (this.up == 2) {
                    var i = h / this.t6.width;
                    c = i - (e / 2);
                }
                else {
                    c = h / this.t6.width;
                }
                if (c + e > this.wd.right) {
                    c = this.wd.right - e;
                }
                else if (c < this.wd.left) {
                    c = this.wd.left;
                }
            }
            if (f > this.wd.height) {
            }
            else {
                var j = new ScalerParams(1, XamGeographicMap.we, this.t6, this.ug.ch);
                j.c = this.tv;
                var k = this.ug.ej(b, j);
                if (this.up == 2) {
                    var l = k / this.t6.height;
                    d = l - (f / 2);
                }
                else {
                    d = k / this.t6.height;
                }
                if (d + f > this.wd.bottom) {
                    d = this.wd.bottom - f;
                }
                else if (d < this.wd.top) {
                    d = this.wd.top;
                }
            }
            this.py(new Rect(0, c, d, e, f), false);
        }
    };
    XamGeographicMap.prototype.get_en = function () {
        return true;
    };
    XamGeographicMap.prototype.ts = function () {
        var a = _super.prototype.ts.call(this);
        if (this.ue == null || this.ug == null) {
            return a;
        }
        this.t2();
        var b = a.left;
        var c = a.top;
        if (this.cd == 1) {
            if (this.t7.width > this.wd.width) {
                b = 0.5 - (this.t7.width / 2);
            }
            else if (b + a.width > this.wd.right) {
                b = this.wd.right - this.t7.width;
            }
            else if (b < this.wd.left) {
                b = this.wd.left;
            }
            if (this.t7.height > this.wd.height) {
                c = 0.5 - (this.t7.height / 2);
            }
            else if (c + this.t7.height > this.wd.bottom) {
                c = this.wd.bottom - this.t7.height;
            }
            else if (c < this.wd.top) {
                c = this.wd.top;
            }
        }
        var d = false;
        if (!this.uv && this.cd == 2 && this.us) {
            if (b > 1) {
                b = (b - Math.floor(b)) + 1;
            }
            if (b < 0) {
                b = 0 - (Math.ceil(b) - b);
            }
            if ((a.right - this.wd.right) > 0 && ((a.right - this.wd.right) / a.width) > 0.8) {
                b = this.wd.left - (a.width - (a.right - this.wd.right));
                d = true;
            }
            else if (a.left < this.wd.left && (Math.abs(a.left - this.wd.left) / a.width) > 0.8) {
                b = this.wd.right - (Math.abs(a.left - this.wd.left));
                d = true;
            }
        }
        var e = new Rect(0, b, c, a.width, a.height);
        if (this.uv) {
            var f = this.wg(this.wr, 1);
            f = this.wi(f);
            var g = e.left + e.width / 2;
            var h = e.top + e.height / 2;
            if (e.width > f.width) {
                var i = e.height / e.width;
                var j = f.width;
                var k = i * j;
                e = new Rect(0, g - j / 2, h - k / 2, j, k);
                d = true;
            }
            if (e.height > f.height) {
                var l = e.width / e.height;
                var m = f.height;
                var n = l * m;
                e = new Rect(0, g - n / 2, h - m / 2, n, m);
                d = true;
            }
            if (e.left < f.left) {
                e = new Rect(0, f.left, e.top, e.width, e.height);
                d = true;
            }
            if (e.top < f.top) {
                e = new Rect(0, e.left, f.top, e.width, e.height);
                d = true;
            }
            if (e.right > f.right) {
                e = new Rect(0, f.right - e.width, e.top, e.width, e.height);
                d = true;
            }
            if (e.bottom > f.bottom) {
                e = new Rect(0, e.left, f.bottom - e.height, e.width, e.height);
                d = true;
            }
        }
        if (d) {
            this.ea = true;
            this.t7 = e;
            this.ea = false;
        }
        return e;
    };
    XamGeographicMap.prototype.lp = function (a, b) {
        var c = true;
        var d = true;
        var e = 0;
        var f = this.t2();
        var g = 0;
        var h = 0;
        if ((a.right - f.right) > 0) {
            g = ((a.right - f.right) / a.width);
        }
        if (a.left < f.left) {
            h = (Math.abs(a.left - f.left) / a.width);
        }
        if (h == 0 && g == 0) {
            c = false;
        }
        if (h > g) {
            d = false;
        }
        if (c) {
            if (d) {
                var i = this.ud.ej(-180, b);
                var j = this.ud.ej(180, b);
                e = j - i;
            }
            else {
                var k = this.ud.ej(-180, b);
                var l = this.ud.ej(180, b);
                e = k - l;
            }
        }
        return new Tuple$2(Boolean_$type, Number_$type, c, e);
    };
    XamGeographicMap.prototype.t2 = function () {
        var a = new ScalerParams(1, XamGeographicMap.we, this.t6, this.ue.ch);
        a.c = this.tv;
        var b = new ScalerParams(1, XamGeographicMap.we, this.t6, this.ug.ch);
        b.c = this.tv;
        var c = this.ue.ej(XamGeographicMap.wb.left, a);
        var d = this.ue.ej(XamGeographicMap.wb.right, a);
        var e = this.ug.ej(XamGeographicMap.wb.top, b);
        var f = this.ug.ej(XamGeographicMap.wb.bottom, b);
        this.wd = new Rect(0, c / this.t6.width, f / this.t6.height, (d - c) / this.t6.width, (e - f) / this.t6.height);
        return this.wd;
    };
    XamGeographicMap.prototype.wi = function (a) {
        var b = this.gm;
        var c = 0.5 * (a.left + a.right);
        var d = 0.5 * (a.top + a.bottom);
        var e = a.width;
        var f = a.height;
        var g = MathUtil.d(a.width, b, 1);
        var h = MathUtil.d(a.height, b, 1);
        var i = this.t6;
        var j = i.width / i.height;
        var k = g * i.width;
        var l = h * i.height;
        var m = k / l;
        if (m != j) {
            if (l * j > k) {
                k = l * j;
                g = k / i.width;
            }
            else {
                l = k / j;
                h = l / i.height;
            }
        }
        var n = g != e;
        var o = h != f;
        var p = n ? c - 0.5 * g : a.left;
        var q = o ? d - 0.5 * h : a.top;
        var r = n ? c + 0.5 * g : a.right;
        var s = o ? d + 0.5 * h : a.bottom;
        if (p < 0) {
            p = 0;
            r = p + g;
        }
        if (r > 1) {
            r = 1;
            p = r - g;
        }
        if (q < 0) {
            q = 0;
            s = q + h;
        }
        if (s > 1) {
            s = 1;
            q = s - h;
        }
        return new Rect(0, p, q, r - p, s - q);
    };
    XamGeographicMap.prototype.tt = function (a) {
        _super.prototype.tt.call(this, this.t6);
        if (a.isEmpty) {
            return Rect.empty;
        }
        var b;
        if (a.width > a.height) {
            var c = intDivide(truncate((a.width - a.height)), 2);
            b = new Rect(0, a.left + c, a.top, a.height, a.height);
        }
        else {
            var d = intDivide(truncate((a.height - a.width)), 2);
            b = new Rect(0, a.left, a.top + d, a.width, a.width);
        }
        return b;
    };
    XamGeographicMap.prototype.wk = function (a) {
        return this.tt(a);
    };
    XamGeographicMap.prototype.ct = function () {
        return new XamGeographicMapView(this);
    };
    XamGeographicMap.prototype.vk = function (a) {
        if (a != null) {
            a.bi = this;
        }
    };
    XamGeographicMap.prototype.n8 = function (a) {
        _super.prototype.n8.call(this, a);
        this.uq = a;
    };
    XamGeographicMap.prototype.oj = function (a, b) {
        _super.prototype.oj.call(this, a, b);
        this.pl(this.ue);
        this.pl(this.ug);
        if (Rect.l_op_Inequality(a, b)) {
            this.vp();
        }
        if (this.uv) {
            this.tr = this.ts();
        }
        this.vw();
    };
    Object.defineProperty(XamGeographicMap.prototype, "u0", {
        get: function () {
            return this.uy;
        },
        set: function (a) {
            var b = this.uy;
            this.uy = a;
            this.op("ActualWindowScale", b, this.uy);
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.gs = function () {
        return this.u0;
    };
    XamGeographicMap.prototype.gt = function () {
        return this.u0;
    };
    XamGeographicMap.prototype.pk = function () {
        _super.prototype.pk.call(this);
        var a = Math.min(this.tr.width, this.tr.height);
        this.u0 = a;
    };
    XamGeographicMap.prototype.fc = function () {
        return this.us;
    };
    XamGeographicMap.prototype.ce = function () {
        if (this.cf == 0) {
            if (this.ut) {
                return 2;
            }
        }
        return this.cf;
    };
    XamGeographicMap.prototype.ok = function (a, b, c, d) {
        var e_2, _a, e_3, _b;
        _super.prototype.ok.call(this, a, b, c, d);
        switch (b) {
            case "ZoomCoercionMode":
                this.vl();
                break;
            case "WindowRect":
                this.vt();
                break;
            case XamGeographicMap.$$p[0]:
                this.um = this.un();
                if (this.uj != null) {
                    this.uj.isHorizontalWrappingEnabled = this.um == 2;
                }
                break;
            case XamGeographicMap.$$p[1]:
                this.us = this.ut;
                this.um = this.un();
                this.cd = this.ce();
                if (this.uj != null) {
                    this.uj.isHorizontalWrappingEnabled = this.um == 2;
                }
                break;
            case XamGeographicMap.$$p[4]:
                this.tr = this.ts();
                break;
            case "BackgroundContent":
                if (this.uj != null) {
                    var e = this.uj;
                    e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.vm));
                    this.uj.deferralHandler = null;
                }
                this.uj = typeCast(GeographicMapImagery.$, this.backgroundContent);
                if (this.uj != null) {
                    var f = this.uj;
                    f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.vm));
                    this.uj.deferralHandler = this;
                    this.uj.isHorizontalWrappingEnabled = this.um == 2;
                }
                this.uq.fu(typeCast(GeographicMapImagery.$, c), typeCast(GeographicMapImagery.$, d));
                if (this.uj != null) {
                    this.uj.geographicMap = this;
                    this.uq.fr(this.tr);
                    this.uq.fv(this.gi);
                }
                break;
            case "YAxis":
            case "XAxis":
                this.vr(c);
                this.vk(d);
                break;
            case XamGeographicMap.$$p[6]:
                if (!this.uu) {
                    this.t7 = XamGeographicMap.we;
                }
                this.vl();
                this.vs();
                this.vt();
                this.tr = this.ts();
                this.uq.fs();
                break;
            case "ActualWindowRect":
                this.uq.fr(this.tr);
                break;
            case "ActualWorldRect":
                try {
                    for (var _c = __values(fromEnum(this.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var g = _d.value;
                        g.pr(false);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                break;
            case XamGeographicMap.$$p[5]:
                this.u0 = this.u1;
                break;
            case "ActualWindowScale":
                if (!this.fj) {
                    this.pw(this.gs(), this.gt());
                }
                break;
            case "ActualPixelScalingRatio":
                this.uq.fv(this.gi);
                break;
            case "WindowRectMinWidth":
            case "WindowRectMinHeight":
                var h = d;
                if (isNaN_(h) || isInfinity(h)) {
                    this.gm = 5E-06;
                    this.gl = 5E-06;
                }
                else {
                    this.gm = h;
                    this.gl = h;
                }
                break;
            case XamGeographicMap.$$p[7]:
                this.ps();
                break;
            case "MarkerAutomaticBehavior":
                try {
                    for (var _e = __values(fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var i = _f.value;
                        i.oh();
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
                break;
        }
    };
    XamGeographicMap.prototype.vm = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new ImageTilesReadyEventArgs());
        }
    };
    XamGeographicMap.prototype.vr = function (a) {
        if (a != null) {
            a.bi = null;
        }
    };
    XamGeographicMap.prototype.vs = function () {
        if (this.ue != null) {
            this.ue.l5 = this.wf.left;
            this.ue.l4 = this.wf.right;
        }
        if (this.ug != null) {
            this.ug.l5 = this.wf.top;
            this.ug.l4 = this.wf.bottom;
        }
        this.ue.c2(true);
        this.ug.c2(true);
    };
    XamGeographicMap.prototype.getFontInfo = function () {
        this.ur = this.uq.fo;
        return this.ur;
    };
    XamGeographicMap.prototype.sw = function () {
        return this.uq.fw;
    };
    XamGeographicMap.prototype.getFontBrush = function () {
        return this.uq.fx;
    };
    XamGeographicMap.prototype.pd = function (a, b) {
        if (typeCast(ItfConverter.$, b) !== null) {
            var c = b;
            var d = a;
            d.itemsSource = c.triangulationSource.points;
            d.ue = c.triangulationSource.triangles;
        }
        else {
            _super.prototype.pd.call(this, a, b);
        }
    };
    XamGeographicMap.prototype.register = function (a, b) {
        this.o3(a, b);
    };
    XamGeographicMap.prototype.unRegister = function (a) {
        this.pj(a);
    };
    XamGeographicMap.prototype.deferredRefresh = function () {
        this.l2();
    };
    XamGeographicMap.prototype.deferAction = function (a) {
        if (this.u3 != null) {
            this.u3.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    XamGeographicMap.prototype.vj = function (a) {
        this.pr(a);
    };
    XamGeographicMap.prototype.u4 = function () {
        var a = new ChartVisualData();
        var b = this.ue.fw();
        var c = this.ug.fw();
        a.axes.add1(b);
        a.axes.add1(c);
        for (var d = 0; d < this.series.count; d++) {
            var e = this.series._inner[d].jr();
            a.series.add1(e);
        }
        a.name = this.name;
        a.contentArea = RectData.b(this.t6);
        a.centralArea = RectData.b(this.t6);
        a.plotArea = RectData.b(this.t6);
        return a;
    };
    XamGeographicMap.prototype.ty = function (a, b, c) {
        return a;
    };
    XamGeographicMap.prototype.vn = function () {
    };
    Object.defineProperty(XamGeographicMap.prototype, "wq", {
        get: function () {
            return this.wc;
        },
        set: function (a) {
            this.wc = a;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.vx = function (a) {
        this.wq = a;
        this.vw();
    };
    XamGeographicMap.prototype.vw = function () {
        if (this.ux && !this.wq.isEmpty) {
            var a = this.getZoomFromGeographicRect(this.wq);
            this.wq = Rect.empty;
            this.py(a, false);
        }
    };
    Object.defineProperty(XamGeographicMap.prototype, "ux", {
        get: function () {
            return !this.t6.isEmpty && !this.tv.isEmpty;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.$t = markType(XamGeographicMap, 'XamGeographicMap', SeriesViewer.$, [IMapRenderDeferralHandler_$type]);
    XamGeographicMap.uo = 0;
    XamGeographicMap.wb = new Rect(2, { $type: Point_$type, x: -180, y: -85.05112878 }, { $type: Point_$type, x: 180, y: 85.05112878 });
    XamGeographicMap.we = new Rect(0, 0, 0, 1, 1);
    XamGeographicMap.$$p = markDep(DependencyProperty, PropertyMetadata, XamGeographicMap, 'op', ['BackgroundTilingMode:ul:vy', [MapBackgroundTilingMode_$type, enumGetBox(MapBackgroundTilingMode_$type, 0)], 'IsHorizontalWrappingEnabled:ut:vz', [0, false], 'ResizeBehavior:up:v0', [MapResizeBehavior_$type, enumGetBox(MapResizeBehavior_$type, XamGeographicMap.uo)], 'SuppressZoomResetOnWorldRectChange:uu:v1', [0, false], 'UseWorldRectForZoomBounds:uv:v2', [0, false], 'WindowScale:u1:v3', [1, NaN], 'WorldRect:wr:v4', [Rect.$, XamGeographicMap.wb], 'Zoomable:uw:v5', [0, true]]);
    return XamGeographicMap;
}(SeriesViewer));
export { XamGeographicMap };
/**
 * @hidden
 */
var GeographicMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapImagery, _super);
    function GeographicMapImagery(a) {
        var _this = _super.call(this) || this;
        _this.ak = null;
        _this.imageTilesReady = null;
        _this.an = null;
        _this.ap = null;
        _this.propertyChanged = null;
        _this.imagesChanged = null;
        _this.cancellingImage = null;
        _this.downloadingImage = null;
        _this.ab = GeographicMapImagery.$;
        _this.ap = a;
        _this.aj = _this.ai();
        _this.bb(_this.aj);
        return _this;
    }
    GeographicMapImagery.prototype.bb = function (a) {
    };
    GeographicMapImagery.prototype.ai = function () {
        return new GeographicMapImageryView(this);
    };
    Object.defineProperty(GeographicMapImagery.prototype, "deferralHandler", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            this.ak = a;
            if (this.ao != null) {
                this.ao.al = a;
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.prototype.a5 = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new ImageTilesReadyEventArgs());
        }
    };
    GeographicMapImagery.prototype.a9 = function () {
        var a = this.ao;
        a.imageTilesReady = delegateCombine(a.imageTilesReady, runOn(this, this.a5));
        this.ao.al = this.deferralHandler;
        var b = this.ao;
        b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.a4));
        var c = this.ao;
        c.downloadingImage = delegateCombine(c.downloadingImage, runOn(this, this.a3));
        var d = this.ao;
        d.cancellingImage = delegateCombine(d.cancellingImage, runOn(this, this.a2));
        this.ao.bf = this.referer;
        this.ao.bj = this.userAgent;
        this.ao.av = this.isHorizontalWrappingEnabled;
    };
    GeographicMapImagery.prototype.a3 = function (a, b) {
        if (this.downloadingImage != null) {
            this.downloadingImage(this, b);
        }
    };
    GeographicMapImagery.prototype.a2 = function (a, b) {
        if (this.cancellingImage != null) {
            this.cancellingImage(this, b);
        }
    };
    GeographicMapImagery.prototype.bg = function () {
        if (this.ao != null) {
            this.aj.e();
        }
    };
    GeographicMapImagery.prototype.ba = function (a, b, c) {
        switch (a) {
            case GeographicMapImagery.$$p[3]:
                this.bg();
                break;
            case "GeographicMap":
                this.aj.e();
                break;
            case GeographicMapImagery.$$p[1]:
                if (this.ao != null) {
                    this.ao.bf = this.referer;
                }
                break;
            case GeographicMapImagery.$$p[2]:
                if (this.ao != null) {
                    this.ao.bj = this.userAgent;
                }
                break;
            case GeographicMapImagery.$$p[0]:
                if (this.ao != null) {
                    this.ao.av = this.isHorizontalWrappingEnabled;
                }
                break;
        }
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    Object.defineProperty(GeographicMapImagery.prototype, "geographicMap", {
        get: function () {
            return this.c(GeographicMapImagery.geographicMapProperty);
        },
        set: function (a) {
            this.h(GeographicMapImagery.geographicMapProperty, a);
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.a8 = function (a, b) {
        a.a7(b.oldValue, b.newValue);
    };
    GeographicMapImagery.prototype.a7 = function (a, b) {
        this.ba("GeographicMap", a, b);
    };
    GeographicMapImagery.prototype.clearTileCache = function () {
        if (this.ao != null) {
            this.ao.bs(0, 0, 0, 0);
        }
    };
    Object.defineProperty(GeographicMapImagery.prototype, "ao", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            this.an = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("MultiScaleImage"));
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.prototype.bn = function (a) {
        if (this.geographicMap == null || a.width < 1 || a.height < 1) {
            return a;
        }
        var b = new Rect(0, 0, 0, a.width, a.height);
        var c = this.geographicMap.wk(b);
        var d = XamGeographicMap.wb;
        var e = this.geographicMap.wf;
        var f = Math.min(this.windowRect.height, this.windowRect.width);
        var g = e.width / d.width;
        this.ao.a5 = (b.width / c.width) * f * g;
        var h = this.geographicMap.ue;
        var i = this.geographicMap.ug;
        var j = new ScalerParams(1, this.windowRect, b, h.ch);
        j.c = c;
        var k = new ScalerParams(1, this.windowRect, b, i.ch);
        k.c = c;
        var l = h.ej(d.left, j);
        var m = i.ej(d.bottom, k);
        var n = (-l / b.width) * this.ao.a5;
        var o = (-m / b.height) * this.ao.a5 * (b.height / b.width);
        this.ao.cm = { $type: Point_$type, x: n, y: o };
        return a;
    };
    GeographicMapImagery.prototype.bd = function (a) {
        this.aj.f(a);
    };
    GeographicMapImagery.prototype.bf = function (a) {
        this.aj.h(a);
    };
    GeographicMapImagery.prototype.be = function (a) {
        this.aj.g(a);
    };
    GeographicMapImagery.prototype.a4 = function (a, b) {
        if (this.imagesChanged != null) {
            this.imagesChanged(this, new ImagesChangedEventArgs());
        }
    };
    GeographicMapImagery.prototype.a6 = function () {
        this.aj.e();
    };
    GeographicMapImagery.prototype.bc = function (a) {
        this.aj.i(a);
    };
    GeographicMapImagery.prototype.v = function () {
        _super.prototype.v.call(this);
        this.ap.o = this._opacity;
    };
    GeographicMapImagery.$t = markType(GeographicMapImagery, 'GeographicMapImagery', Control.$, [INotifyPropertyChanged_$type]);
    GeographicMapImagery.geographicMapProperty = DependencyProperty.i("GeographicMap", XamGeographicMap.$, GeographicMapImagery.$, new PropertyMetadata(2, null, GeographicMapImagery.a8));
    GeographicMapImagery.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicMapImagery, 'ba', ['IsHorizontalWrappingEnabled', [0, false], 'Referer', [2, null], 'UserAgent', [2, null], 'WindowRect', [Rect.$, Rect.empty]]);
    return GeographicMapImagery;
}(Control));
export { GeographicMapImagery };
/**
 * @hidden
 */
var GeographicMapImageryView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapImageryView, _super);
    function GeographicMapImageryView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.j = null;
        _this.d = null;
        _this.b = 1;
        _this.j = Rect.empty;
        _this.a = a;
        _this.a.ao = new XamMultiScaleImage();
        _this.a.ao.ao = _this.a.ap;
        _this.a.a9();
        return _this;
    }
    GeographicMapImageryView.prototype.e = function () {
        if (this.j.isEmpty) {
            return;
        }
        this.a.bn(new Size(1, this.j.width, this.j.height));
    };
    GeographicMapImageryView.prototype.f = function (a) {
        this.a.ao.b1(a);
    };
    GeographicMapImageryView.prototype.g = function (a) {
        this.d = a;
        this.a.ao.b2(a);
    };
    GeographicMapImageryView.prototype.h = function (a) {
        this.j = a;
        this.a.ao.b3(a);
        this.a.a6();
    };
    Object.defineProperty(GeographicMapImageryView.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImageryView.prototype.i = function (a) {
        this.b = a;
        this.a.ao.bz(a);
    };
    GeographicMapImageryView.$t = markType(GeographicMapImageryView, 'GeographicMapImageryView');
    return GeographicMapImageryView;
}(Base));
export { GeographicMapImageryView };
/**
 * @hidden
 */
var GeographicXYTriangulatingSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicXYTriangulatingSeriesView, _super);
    function GeographicXYTriangulatingSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.ch = null;
        _this.ch = a;
        return _this;
    }
    GeographicXYTriangulatingSeriesView.prototype.b5 = function () {
        _super.prototype.b5.call(this);
        var a = this.ch.t5;
        a.u5 = this.ch.uh;
        a.vd = this.ch.uf;
        a.trianglesSource = this.ch.ue;
        a.ut = this.ch.uk;
        a.uv = this.ch.um;
        a.ux = this.ch.uo;
    };
    GeographicXYTriangulatingSeriesView.prototype.ck = function () {
        var a = this.ch.t5;
        if (this.ch.cv == null) {
            a.t3 = null;
            a.t4 = null;
            return;
        }
        a.t3 = this.ch.cv.ue;
        a.t4 = this.ch.cv.ug;
    };
    GeographicXYTriangulatingSeriesView.prototype.cj = function () {
        this.ch.t5.u5 = this.ch.uh;
    };
    GeographicXYTriangulatingSeriesView.prototype.ci = function () {
        this.ch.t5.vd = this.ch.uf;
    };
    GeographicXYTriangulatingSeriesView.prototype.cl = function () {
        this.ch.t5.trianglesSource = this.ch.ue;
    };
    GeographicXYTriangulatingSeriesView.prototype.cm = function () {
        this.ch.t5.ut = this.ch.uk;
    };
    GeographicXYTriangulatingSeriesView.prototype.cn = function () {
        this.ch.t5.uv = this.ch.um;
    };
    GeographicXYTriangulatingSeriesView.prototype.co = function () {
        this.ch.t5.ux = this.ch.uo;
    };
    GeographicXYTriangulatingSeriesView.$t = markType(GeographicXYTriangulatingSeriesView, 'GeographicXYTriangulatingSeriesView', HostSeriesView.$);
    return GeographicXYTriangulatingSeriesView;
}(HostSeriesView));
export { GeographicXYTriangulatingSeriesView };
/**
 * @hidden
 */
var GeographicScatterAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicScatterAreaSeriesView, _super);
    function GeographicScatterAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cp = null;
        _this.cp = a;
        return _this;
    }
    GeographicScatterAreaSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
        }
    };
    GeographicScatterAreaSeriesView.prototype.b5 = function () {
        _super.prototype.b5.call(this);
        if (this.cp.uz != null) {
            this.cp.uz.wc = this.cp.u3;
            this.cp.uz.v0 = this.cp.uy;
        }
    };
    GeographicScatterAreaSeriesView.prototype.cq = function () {
        if (this.cp.uz != null) {
            this.cp.uz.wc = this.cp.u3;
        }
    };
    GeographicScatterAreaSeriesView.prototype.cr = function () {
        if (this.cp.uz != null) {
            this.cp.uz.v0 = this.cp.uy;
        }
    };
    GeographicScatterAreaSeriesView.$t = markType(GeographicScatterAreaSeriesView, 'GeographicScatterAreaSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicScatterAreaSeriesView;
}(GeographicXYTriangulatingSeriesView));
export { GeographicScatterAreaSeriesView };
/**
 * @hidden
 */
var XamGeographicMapView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamGeographicMapView, _super);
    function XamGeographicMapView(a) {
        var _this = _super.call(this, a) || this;
        _this.fn = null;
        _this.fz = null;
        _this.fx = null;
        _this.fw = null;
        _this.fo = null;
        _this.fp = NaN;
        _this.fz = Rect.empty;
        _this.fn = a;
        _this.fn.sr = 2;
        _this.fn.hr = 5E-06;
        return _this;
    }
    XamGeographicMapView.prototype.m = function (a) {
        return 2;
    };
    XamGeographicMapView.prototype.bk = function (a) {
        this.j.bw(a);
        this.fn.vj(a);
        this.el();
    };
    XamGeographicMapView.prototype.get_ap = function () {
        return true;
    };
    XamGeographicMapView.prototype.d4 = function () {
        var a;
        var b;
        var c;
        var d;
        var e;
        var f = this.j.a8(a, b, c, d, e);
        a = f.p0;
        b = f.p1;
        c = f.p2;
        d = f.p3;
        e = f.p4;
        this.fx = c;
        this.fo = d;
        this.fw = e;
        var g = this.j.e();
        this.fn.ag = g.a;
        this.fn.aj = g.f;
        this.fn.ah = g.b != null ? g.b : new BrushCollection();
        this.fn.ai = g.c != null ? g.c : new BrushCollection();
        if (this.fn.ah.count == 0) {
            for (var h = 0; h < g.a.count; h++) {
                this.fn.ah.add(g.a.item(h));
            }
        }
        if (g.c.count == 0) {
            for (var i = 0; i < g.f.count; i++) {
                this.fn.ai.add(g.f.item(i));
            }
        }
    };
    XamGeographicMapView.prototype.du = function (a) {
        _super.prototype.du.call(this, a);
        if (this.fn.backgroundContent != null) {
            var b = this.fn.backgroundContent;
            b.be(this.j.ae);
            b.bd(a);
        }
    };
    XamGeographicMapView.prototype.dv = function (a) {
        _super.prototype.dv.call(this, a);
        this.fz = a;
        if (this.fn.backgroundContent != null) {
            var b = this.fn.backgroundContent;
            b.bf(this.fz);
        }
    };
    XamGeographicMapView.prototype.fy = function () {
        return new Rect(0, 0, 0, this.fz.width, this.fz.height);
    };
    XamGeographicMapView.prototype.fs = function () {
        if (this.fn.backgroundContent != null) {
            var a = this.fn.backgroundContent;
            a.a6();
        }
    };
    XamGeographicMapView.prototype.fr = function (a) {
        if (this.fn.uj != null) {
            this.fn.uj.windowRect = a;
        }
    };
    XamGeographicMapView.prototype.fu = function (a, b) {
        if (this.fn.uj != null) {
            this.fn.uj.windowRect = this.fn.tr;
        }
        if (a != null) {
            var c = a.ao;
            if (c != null) {
                this.fn.al.h.remove(c.ag);
            }
            a.bd(null);
            a.be(null);
        }
        if (b != null) {
            var d = b.ao;
            if (d != null) {
                this.fn.al.h.add(d.ag);
            }
            if (!this.fz.isEmpty) {
                this.dv(this.fz);
            }
            if (this.w != null) {
                this.du(this.w);
            }
        }
        if (b == null) {
            this.ft(this.w);
        }
    };
    XamGeographicMapView.prototype.ft = function (a) {
        var b = this.fn.gi;
        if (b != 1) {
            a.aa();
            a.ab(b, b);
        }
        a.l(this.fz.left, this.fz.top, this.fz.width, this.fz.height);
        if (b != 1) {
            a.z();
        }
    };
    XamGeographicMapView.prototype.d1 = function () {
        this.fd.ad = Defaults.j;
        this.fe.ad = Defaults.j;
        this.fd._stroke = Defaults.ae;
        this.fe._stroke = Defaults.ae;
        _super.prototype.d1.call(this);
    };
    XamGeographicMapView.prototype.fv = function (a) {
        this.fp = a;
        if (this.fn.backgroundContent != null) {
            this.fn.backgroundContent.bc(a);
        }
    };
    Object.defineProperty(XamGeographicMapView.prototype, "fq", {
        get: function () {
            return this.fp;
        },
        set: function (a) {
            this.fp = a;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMapView.$t = markType(XamGeographicMapView, 'XamGeographicMapView', SeriesViewerView.$);
    return XamGeographicMapView;
}(SeriesViewerView));
export { XamGeographicMapView };
/**
 * @hidden
 */
var OpenStreetMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OpenStreetMapImagery, _super);
    function OpenStreetMapImagery() {
        return _super.call(this, new OpenStreetMapTileSource()) || this;
    }
    Object.defineProperty(OpenStreetMapImagery.prototype, "tilePath", {
        get: function () {
            return this.c(OpenStreetMapImagery.tilePathProperty);
        },
        set: function (a) {
            this.h(OpenStreetMapImagery.tilePathProperty, a);
        },
        enumerable: false,
        configurable: true
    });
    OpenStreetMapImagery.br = function (a, b) {
        a.bq("TilePath", b.oldValue, b.newValue);
    };
    OpenStreetMapImagery.prototype.bq = function (a, b, c) {
        switch (a) {
            case "TilePath":
                this.ap.setTilePathUrl(c == null ? null : c);
                this.aj.e();
                break;
        }
        _super.prototype.ba.call(this, a, b, c);
    };
    OpenStreetMapImagery.$t = markType(OpenStreetMapImagery, 'OpenStreetMapImagery', GeographicMapImagery.$);
    OpenStreetMapImagery.tilePathProperty = DependencyProperty.i("TilePath", String_$type, OpenStreetMapImagery.$, new PropertyMetadata(2, null, OpenStreetMapImagery.br));
    return OpenStreetMapImagery;
}(GeographicMapImagery));
export { OpenStreetMapImagery };
/**
 * @hidden
 */
var GeographicXYTriangulatingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicXYTriangulatingSeries, _super);
    function GeographicXYTriangulatingSeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GeographicXYTriangulatingSeries.prototype.cd = function () {
        return new GeographicXYTriangulatingSeriesView(this);
    };
    GeographicXYTriangulatingSeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.ud = a;
    };
    GeographicXYTriangulatingSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.ud.ck();
                break;
            case GeographicXYTriangulatingSeries.$$p[1]:
                this.ud.cj();
                break;
            case GeographicXYTriangulatingSeries.$$p[0]:
                this.ud.ci();
                break;
            case GeographicXYTriangulatingSeries.$$p[5]:
                this.ud.cl();
                break;
            case GeographicXYTriangulatingSeries.$$p[2]:
                this.ud.cm();
                break;
            case GeographicXYTriangulatingSeries.$$p[3]:
                this.ud.cn();
                break;
            case GeographicXYTriangulatingSeries.$$p[4]:
                this.ud.co();
                break;
        }
    };
    GeographicXYTriangulatingSeries.$t = markType(GeographicXYTriangulatingSeries, 'GeographicXYTriangulatingSeries', GeographicMapSeriesHost.$);
    GeographicXYTriangulatingSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicXYTriangulatingSeries, 'raisePropertyChanged', ['LatitudeMemberPath:uf:uq', [2, "pointY"], 'LongitudeMemberPath:uh:ur', [2, "pointX"], 'TriangleVertexMemberPath1:uk:ut', [2, "v1"], 'TriangleVertexMemberPath2:um:uu', [2, "v2"], 'TriangleVertexMemberPath3:uo:uv', [2, "v3"], 'TrianglesSource:ue:us', [IEnumerable_$type, null]]);
    return GeographicXYTriangulatingSeries;
}(GeographicMapSeriesHost));
export { GeographicXYTriangulatingSeries };
/**
 * @hidden
 */
var GeographicScatterAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicScatterAreaSeries, _super);
    function GeographicScatterAreaSeries() {
        var _this = _super.call(this) || this;
        _this.uw = null;
        _this.triangulationStatusChanged = null;
        _this.ab = GeographicScatterAreaSeries.$;
        return _this;
    }
    GeographicScatterAreaSeries.prototype.bc = function () {
        return new GeographicScatterAreaSeries();
    };
    GeographicScatterAreaSeries.prototype.get_d9 = function () {
        return true;
    };
    Object.defineProperty(GeographicScatterAreaSeries.prototype, "uy", {
        get: function () {
            return this.uw;
        },
        set: function (a) {
            var b = this.uw != a;
            if (b) {
                var c = this.uw;
                if (this.uw != null) {
                    var d = this.uw;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.u6));
                }
                this.uw = a;
                if (this.uw != null) {
                    var e = this.uw;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.u6));
                }
                this.raisePropertyChanged("ColorScale", c, this.uw);
                if (this.uz != null) {
                    this.uz.v0 = a;
                }
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicScatterAreaSeries.prototype.u6 = function (a, b) {
        this.u1.cr();
        this.u8();
        this.pr(false);
    };
    GeographicScatterAreaSeries.prototype.u8 = function () {
        if (this.uz != null) {
            this.ux = this.uz.vz;
        }
    };
    GeographicScatterAreaSeries.prototype.qf = function () {
        _super.prototype.qf.call(this);
        this.u8();
    };
    GeographicScatterAreaSeries.prototype.t4 = function () {
        this.uz = new ScatterAreaSeries();
        var a = this.uz;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.u7));
        return this.uz;
    };
    GeographicScatterAreaSeries.prototype.u7 = function (a, b) {
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, b);
        }
    };
    GeographicScatterAreaSeries.prototype.cd = function () {
        return new GeographicScatterAreaSeriesView(this);
    };
    GeographicScatterAreaSeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.u1 = a;
    };
    GeographicScatterAreaSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case GeographicScatterAreaSeries.$$p[1]:
                this.u1.cq();
                break;
            case "ColorScale":
                this.u1.cr();
                this.u8();
                break;
        }
    };
    GeographicScatterAreaSeries.prototype.get_gg = function () {
        return true;
    };
    GeographicScatterAreaSeries.prototype.set_gg = function (a) {
        _super.prototype.set_gg.call(this, a);
    };
    GeographicScatterAreaSeries.$t = markType(GeographicScatterAreaSeries, 'GeographicScatterAreaSeries', GeographicXYTriangulatingSeries.$);
    GeographicScatterAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:ux:u9', [ColorScale.$, null], 'ColorMemberPath:u3:va', [2, "value"]]);
    return GeographicScatterAreaSeries;
}(GeographicXYTriangulatingSeries));
export { GeographicScatterAreaSeries };
