import { __extends } from "tslib";
import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { ArcGISOnlineMapImagery as ArcGISOnlineMapImagery_internal } from "./ArcGISOnlineMapImagery";
import { ensureBool } from "igniteui-webcomponents-core";
/**
 * UI element class used to display ArcGIS Online Map imagery in the IgxGeographicMap.Component
*/
var IgcArcGISOnlineMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcArcGISOnlineMapImagery, _super);
    function IgcArcGISOnlineMapImagery() {
        return _super.call(this) || this;
    }
    IgcArcGISOnlineMapImagery.prototype.createImplementation = function () {
        return new ArcGISOnlineMapImagery_internal();
    };
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "mapServerUri", {
        /**
         * Gets or sets the map tile server uri.
        */
        get: function () {
            return this.i.mapServerUri;
        },
        set: function (v) {
            this.i.mapServerUri = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "userName", {
        /**
         * Gets or sets the UserName.
        */
        get: function () {
            return this.i.userName;
        },
        set: function (v) {
            this.i.userName = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "password", {
        /**
         * Gets or sets the Password.
        */
        get: function () {
            return this.i.password;
        },
        set: function (v) {
            this.i.password = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "userToken", {
        /**
         * Gets or sets the UserToken.
        */
        get: function () {
            return this.i.userToken;
        },
        set: function (v) {
            this.i.userToken = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "isMapPublic", {
        /**
         * Gets or sets the IsMapPublic variable.  A value of false requires authentication parameters.
        */
        get: function () {
            return this.i.isMapPublic;
        },
        set: function (v) {
            this.i.isMapPublic = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "defaultTokenTimeout", {
        /**
         * Gets or Sets the Default Token Timeout before the Token Expires, this value is in Minutes
        */
        get: function () {
            return this.i.defaultTokenTimeout;
        },
        set: function (v) {
            this.i.defaultTokenTimeout = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "tokenGenerationEndPoint", {
        /**
         * Gets or Sets the current endpoint to retrieve the token.
        */
        get: function () {
            return this.i.tokenGenerationEndPoint;
        },
        set: function (v) {
            this.i.tokenGenerationEndPoint = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcArcGISOnlineMapImagery.prototype, "refererUri", {
        /**
         * Contains the User Supplied Referer Uri to be used in Token Generation.
        */
        get: function () {
            return this.i.refererUri;
        },
        set: function (v) {
            this.i.refererUri = v;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Retreives a new token based on the preconfigured parameters and updates the UserToken field, Normal this is called automatically.
     * The is provided to the end-user to allow them to reteive tokens on their onw.
    
    */
    IgcArcGISOnlineMapImagery.prototype.acquireNewToken = function () {
        this.i.acquireNewToken();
    };
    return IgcArcGISOnlineMapImagery;
}(IgcGeographicMapImagery));
export { IgcArcGISOnlineMapImagery };
