import { __extends } from "tslib";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { IgcGetTileImageUriArgs } from "igniteui-webcomponents-core";
import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
/**
 * Represents a CustomMapImagery MapImagery
*/
var IgcCustomMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcCustomMapImagery, _super);
    function IgcCustomMapImagery() {
        var _this = _super.call(this) || this;
        _this._getTileImageUri = null;
        _this._getTileImageUri_wrapped = null;
        return _this;
    }
    Object.defineProperty(IgcCustomMapImagery.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcCustomMapImagery.prototype, "getTileImageUri", {
        /**
         * Raised when URI for tiles should be provided
        */
        get: function () {
            return this._getTileImageUri;
        },
        set: function (ev) {
            var _this = this;
            if (this._getTileImageUri_wrapped !== null) {
                this.i.getTileImageUri = delegateRemove(this.i.getTileImageUri, this._getTileImageUri_wrapped);
                this._getTileImageUri_wrapped = null;
                this._getTileImageUri = null;
            }
            this._getTileImageUri = ev;
            this._getTileImageUri_wrapped = function (o, e) {
                var outerArgs = new IgcGetTileImageUriArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeGetTileImageUri) {
                    _this.beforeGetTileImageUri(_this, outerArgs);
                }
                if (_this._getTileImageUri) {
                    _this._getTileImageUri(_this, outerArgs);
                }
            };
            this.i.getTileImageUri = delegateCombine(this.i.getTileImageUri, this._getTileImageUri_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    return IgcCustomMapImagery;
}(IgcGeographicMapImagery));
export { IgcCustomMapImagery };
