/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { IgcSeriesComponent } from "igniteui-webcomponents-charts";
import { IgcSeriesViewerComponent } from "igniteui-webcomponents-charts";
import { WebComponentRenderer, WebComponentWrapper } from "igniteui-webcomponents-core";
import { TypeRegistrar, delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { XamGeographicMap } from './XamGeographicMap';
import { CollectionAdapter, toPoint, fromPoint, toRect, fromRect, ensureBool, ensureEnum, NamePatcher, enumToString, rectToString, toSpinal } from "igniteui-webcomponents-core";
import { DataChartStylingDefaults } from "igniteui-webcomponents-charts";
import { IgcDataContext } from "igniteui-webcomponents-core";
import { IgcSeriesCollection } from "igniteui-webcomponents-charts";
import { NotifyCollectionChangedAction } from "igniteui-webcomponents-core";
import { getAllPropertyNames } from "igniteui-webcomponents-core";
import { IgcNumericXAxisComponent } from "igniteui-webcomponents-charts";
import { IgcNumericYAxisComponent } from "igniteui-webcomponents-charts";
import { IgcImageTilesReadyEventArgs } from './igc-image-tiles-ready-event-args';
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { MapResizeBehavior_$type } from './MapResizeBehavior';
import { MapBackgroundTilingMode_$type } from './MapBackgroundTilingMode';
var IgcGeographicMapComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcGeographicMapComponent, _super);
    function IgcGeographicMapComponent() {
        var _this = _super.call(this) || this;
        _this.contentSeries = [];
        /**
         * The series actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing Angular to reproject the child content.
         * Or adding and removing series from the manual series collection on the series property.
         */
        _this.actualSeries = [];
        _this._series = null;
        _this._dataSource = null;
        _this._seriesAdapter = null;
        _this._disconnected = false;
        _this._defaultTooltips = null;
        _this._imageTilesReady = null;
        _this._imageTilesReady_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._renderer = new WebComponentRenderer(_this, document, true, DataChartStylingDefaults);
        //this._implementation = this.createImplementation();
        _this._container = _this._renderer.createElement("div");
        _this._renderer.updateRoot(_this._container);
        //this._renderer.rootWrapper.append(this._container);
        _this._container.setStyleProperty("display", "block");
        _this._container.setStyleProperty("width", "100%");
        _this._container.setStyleProperty("height", "100%");
        var root;
        root = _this._container;
        if (_this._container.nativeElement != null) {
            root = _this._container.nativeElement;
        }
        _this._wrapper = _this._renderer;
        var chart = _this.i;
        _this._chart = chart;
        _this._seriesAdapter = new CollectionAdapter(_this.contentSeries, _this.i.series, _this.actualSeries, function (c) { return c.i; }, function (i) {
            i.owner = _this;
            i._provideRenderer(_this._dataSource);
            i.provideData(_this._dataSource);
            if (_this.parentElement) {
                i._styling(_this, _this, _this);
            }
            //i.bindAxes(this.axes);
            _this._ensureDefaultTooltip(i);
            _this._ensureTooltipCreated(i);
        }, function (i) { i._provideRenderer(null); i.provideData(null); });
        chart.provideContainer(_this._renderer);
        var mut = new MutationObserver(function (list) {
            var e_1, _b;
            try {
                for (var list_1 = __values(list), list_1_1 = list_1.next(); !list_1_1.done; list_1_1 = list_1.next()) {
                    var mutation = list_1_1.value;
                    if (mutation.type == 'childList') {
                        _this.updateContentChildren();
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (list_1_1 && !list_1_1.done && (_b = list_1.return))
                        _b.call(list_1);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        });
        mut.observe(_this, {
            childList: true
        });
        _this._renderer.addSizeWatcher(function () {
            _this.notifyContainerResized();
        });
        return _this;
    }
    Object.defineProperty(IgcGeographicMapComponent.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            this.style.height = value;
            this.notifyContainerResized();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            this.style.width = value;
            this.notifyContainerResized();
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicMapComponent.prototype.notifyContainerResized = function () {
        this._chart.notifyContainerResized();
    };
    Object.defineProperty(IgcGeographicMapComponent.prototype, "legend", {
        /**
         * Gets or sets the legend used for the current chart.
        */
        get: function () {
            if (this.i.legend != null)
                return this.i.legend.externalObject;
        },
        set: function (v) {
            if (v != undefined && v != null)
                this.i.legend = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "series", {
        /**
         * A collection or manually added series for the chart.
        */
        get: function () {
            var _this = this;
            if (this._series === null) {
                var coll = new IgcSeriesCollection();
                var inner = coll._innerColl;
                inner.addListener(function (sender, e) {
                    if (!_this._seriesAdapter) {
                        return;
                    }
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            _this._seriesAdapter.addManualItem(e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            _this._seriesAdapter.clearManualItems();
                            break;
                    }
                });
                this._series = coll;
            }
            return this._series;
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicMapComponent.prototype.destroy = function () {
        this._chart.destroy();
        this._wrapper.destroy();
    };
    IgcGeographicMapComponent.prototype.createImplementation = function () {
        return new XamGeographicMap();
    };
    Object.defineProperty(IgcGeographicMapComponent.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.bindData();
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicMapComponent.prototype.bindData = function () {
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                currSeries[i].provideData(this._dataSource);
            }
        }
    };
    IgcGeographicMapComponent.prototype.updateContentChildren = function () {
        this.contentSeries.length = 0;
        for (var i = 0; i < this.children.length; i++) {
            if (this.children[i] instanceof IgcSeriesComponent) {
                this.contentSeries.push(this.children[i]);
            }
        }
        if (this._seriesAdapter != null) {
            this._seriesAdapter.notifyContentChanged();
        }
    };
    IgcGeographicMapComponent.prototype.disconnectedCallback = function () {
        this._disconnected = true;
        if (this.i) {
            this.i.onDetachedFromUI();
        }
    };
    IgcGeographicMapComponent.prototype.connectedCallback = function () {
        if (this._disconnected) {
            this._disconnected = false;
            if (this.i) {
                this.i.onAttachedToUI();
            }
            return;
        }
        this.classList.add("igc-geographic-map");
        this.classList.add("ig-geographic-map");
        this.appendChild(this._renderer.rootWrapper.getNativeElement());
        this._attached = true;
        this.style.display = "block";
        this.style.height = this._height;
        this.style.width = this._width;
        this._flushQueuedAttributes();
        // supports themes or custom properties set in CSS 
        this._styling(this, this);
        for (var i = 0; i < this.actualSeries.length; i++) {
            var s = this.actualSeries[i];
            s._styling(this, this, this);
        }
        this.updateContentChildren();
        this.afterContentInit();
    };
    IgcGeographicMapComponent.prototype.afterContentInit = function () {
        var _this = this;
        if (TypeRegistrar.isRegistered("IgcDataChartDefaultTooltipsComponent")) {
            var cr_1 = TypeRegistrar.create("IgcDataChartDefaultTooltipsComponent");
            //let cr = cf.create(this._injector);
            this._defaultTooltips = cr_1;
            cr_1.onContentReady = function () {
                _this._onDefaultTooltipsReady(cr_1);
            };
            //this._container.appendChild(cr.location.nativeElement);
        }
        this.i.notifyContainerResized();
    };
    IgcGeographicMapComponent.prototype._ensureTooltipCreated = function (series) {
        var _this = this;
        series._ensureTooltipCreated(function () { return _this.createTooltip(); }, function (ele) {
            var wrapper = new WebComponentWrapper(ele, _this._renderer);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            return wrapper;
        });
    };
    IgcGeographicMapComponent.prototype._ensureDefaultTooltip = function (series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips["ensureDefaultTooltip"](series);
    };
    IgcGeographicMapComponent.prototype._onDefaultTooltipsReady = function (cr) {
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                if (currSeries[i].showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries[i]);
                }
            }
        }
    };
    IgcGeographicMapComponent.prototype.createTooltip = function () {
        if (!TypeRegistrar.isRegistered("IgcTooltipContainerComponent")) {
            return null;
        }
        var cr = TypeRegistrar.create("IgcTooltipContainerComponent");
        var ele = cr;
        var self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                var ext = new IgcDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self._container.getNativeElement()) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self._container.getNativeElement().appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            cr.context = c;
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        return cr;
    };
    Object.defineProperty(IgcGeographicMapComponent.prototype, "backgroundContent", {
        /**
         * An imagery to display behind all series, inside the viewport of the IgxGeographicMapComponent control.
        */
        get: function () {
            if (this.i.backgroundContent != null) {
                return this.i.backgroundContent.externalObject;
            }
            else {
                return null;
            }
        },
        set: function (v) {
            if (typeof (v) == "string" && v == "empty") {
                this.i.backgroundContent = null;
                this._a("backgroundContent", "empty");
                return;
            }
            if (v != undefined && v != null) {
                this.i.backgroundContent = v.i;
            }
            else {
                this.i.backgroundContent = null;
                this._a("backgroundContent", "empty");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "i", {
        /**
                                 * @hidden
                                 */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent, "observedAttributes", {
        get: function () {
            if (IgcGeographicMapComponent._observedAttributesIgcGeographicMapComponent == null) {
                var names = getAllPropertyNames(IgcGeographicMapComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGeographicMapComponent._observedAttributesIgcGeographicMapComponent = names;
            }
            return IgcGeographicMapComponent._observedAttributesIgcGeographicMapComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicMapComponent.register = function () {
        if (!IgcGeographicMapComponent._isElementRegistered) {
            IgcGeographicMapComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcGeographicMapComponent.htmlTagName, IgcGeographicMapComponent);
        }
    };
    Object.defineProperty(IgcGeographicMapComponent.prototype, "zoomable", {
        /**
     * Gets or sets zoomability of the current control
    */
        get: function () {
            return this.i.uw;
        },
        set: function (v) {
            this.i.uw = ensureBool(v);
            this._a("zoomable", this.i.uw);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "resizeBehavior", {
        /**
         * Gets or sets the behavior to use during resize.
        */
        get: function () {
            return this.i.up;
        },
        set: function (v) {
            this.i.up = ensureEnum(MapResizeBehavior_$type, v);
            this._a("resizeBehavior", enumToString(MapResizeBehavior_$type, this.i.up));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "isHorizontalWrappingEnabled", {
        /**
         * Gets or sets if the map should horizontally wrap.
        */
        get: function () {
            return this.i.ut;
        },
        set: function (v) {
            this.i.ut = ensureBool(v);
            this._a("isHorizontalWrappingEnabled", this.i.ut);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "backgroundTilingMode", {
        /**
         * Gets or sets if the map should horizontally wrap.
        */
        get: function () {
            return this.i.ul;
        },
        set: function (v) {
            this.i.ul = ensureEnum(MapBackgroundTilingMode_$type, v);
            this._a("backgroundTilingMode", enumToString(MapBackgroundTilingMode_$type, this.i.ul));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "useWorldRectForZoomBounds", {
        /**
         * Gets or sets whether to use the uncoerced world rect to constrain the zoom bounds.
        */
        get: function () {
            return this.i.uv;
        },
        set: function (v) {
            this.i.uv = ensureBool(v);
            this._a("useWorldRectForZoomBounds", this.i.uv);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "suppressZoomResetOnWorldRectChange", {
        /**
         * Gets or sets whether skip resetting the zoom when the world rect changes.
        */
        get: function () {
            return this.i.uu;
        },
        set: function (v) {
            this.i.uu = ensureBool(v);
            this._a("suppressZoomResetOnWorldRectChange", this.i.uu);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "worldRect", {
        /**
         * Gets or sets the world bounding rectangle.
        */
        get: function () {
            return fromRect(this.i.wr);
        },
        set: function (v) {
            this.i.wr = toRect(v);
            this._a("worldRect", rectToString(this.i.wr));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "actualWorldRect", {
        /**
         * Gets the actual value of the WorldRect.
        */
        get: function () {
            return fromRect(this.i.wf);
        },
        set: function (v) {
            this.i.wf = toRect(v);
            this._a("actualWorldRect", rectToString(this.i.wf));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "xAxis", {
        /**
         * The X-axis for this IgxGeographicMap.Component
         * Under normal circumstances, this property should not be set in application code.  By default, it will be set to a numeric axis with a spherical mercator scaler.
        */
        get: function () {
            var r = this.i.ue;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcNumericXAxisComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.ue = null : this.i.ue = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "yAxis", {
        /**
         * The Y-axis for this IgxGeographicMap.Component
         * Under normal circumstances, this property should not be set in application code.  By default, it will be set to a numeric axis with a spherical mercator scaler.
        */
        get: function () {
            var r = this.i.ug;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcNumericYAxisComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.ug = null : this.i.ug = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "isMap", {
        /**
         * Indicates if this SeriesViewer is a map.
        */
        get: function () {
            return this.i.en;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "windowScale", {
        /**
         * A number between 0 and 1 determining the scale of the horizontal/vertical zoom.
         * This property is effectively a shortcut to the Width/Height of the WindowRect property.
        */
        get: function () {
            return this.i.u1;
        },
        set: function (v) {
            this.i.u1 = +v;
            this._a("windowScale", this.i.u1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "actualWindowScale", {
        /**
         * A number between 0 and 1 determining the scale of the horizontal/vertical zoom.
         * This property is effectively a shortcut to the Width/Height of the ActualWindowRect property.
        */
        get: function () {
            return this.i.u0;
        },
        set: function (v) {
            this.i.u0 = +v;
            this._a("actualWindowScale", this.i.u0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicMapComponent.prototype, "zoomIsReady", {
        /**
         * Gets whether or not the control is ready for zooming
        */
        get: function () {
            return this.i.ux;
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicMapComponent.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.backgroundContent && this.backgroundContent.name && this.backgroundContent.name == name) {
            return this.backgroundContent;
        }
        return null;
    };
    IgcGeographicMapComponent.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
 * Gets current world rect in geographic coordinates

*/
    IgcGeographicMapComponent.prototype.getCurrentActualWorldRect = function () {
        var iv = this.i.wj();
        return fromRect(iv);
    };
    /**
     * Given the current plot area of the control and a geographic region, get the WindowRect that would encompass that geographic region.
    
    * @param geographic  * The geographic area.
    */
    IgcGeographicMapComponent.prototype.getZoomRectFromGeoRect = function (geographic) {
        var iv = this.i.getZoomRectFromGeoRect(toRect(geographic));
        return fromRect(iv);
    };
    /**
     * Updates zoom window using window coordinates
    
    */
    IgcGeographicMapComponent.prototype.updateZoomWindow = function (zoomWindow) {
        this.i.vv(toRect(zoomWindow));
    };
    /**
     * Updates world rect in geographic coordinates
    
    */
    IgcGeographicMapComponent.prototype.updateWorldRect = function (worldRect) {
        this.i.vu(toRect(worldRect));
    };
    /**
     * Given the current plot area of the control and a geographic region, get the WindowRect that would encompass that geographic region.
    
    * @param geographic  * The geographic area.
    */
    IgcGeographicMapComponent.prototype.getZoomFromGeographicRect = function (geographic) {
        var iv = this.i.getZoomFromGeographicRect(toRect(geographic));
        return fromRect(iv);
    };
    IgcGeographicMapComponent.prototype.convertGeographicToZoom = function (geographic, extraPixelPadding) {
        var iv = this.i.wg(toRect(geographic), extraPixelPadding);
        return fromRect(iv);
    };
    IgcGeographicMapComponent.prototype.getZoomFromGeographicPoints = function (northWest, southEast) {
        var iv = this.i.getZoomFromGeographicPoints(toPoint(northWest), toPoint(southEast));
        return fromRect(iv);
    };
    /**
     * Given a WindowRect and the current plot area, get the geographic region represented by that WindowRect.
    
    * @param windowRect  * The zoom area.
    */
    IgcGeographicMapComponent.prototype.getGeographicFromZoom = function (windowRect) {
        var iv = this.i.wl(toRect(windowRect));
        return fromRect(iv);
    };
    /**
     * Convert a pixel-based coordinate to a geographic coordinate.
    
    * @param pixelCoordinate  * A pixel-based coordinate
    */
    IgcGeographicMapComponent.prototype.getGeographicPoint = function (pixelCoordinate) {
        var iv = this.i.v7(toPoint(pixelCoordinate));
        return fromPoint(iv);
    };
    /**
     * Convert a geographic coordinate to a pixel-based coordinate.
    
    * @param geographicCoordinate  * A geographic coordinate
    */
    IgcGeographicMapComponent.prototype.getPixelPoint = function (geographicCoordinate) {
        var iv = this.i.v8(toPoint(geographicCoordinate));
        return fromPoint(iv);
    };
    /**
     * Convert a geographic coordinate to a pixel-based coordinate.
    
    * @param geographicCoordinate  * A geographic coordinate
    */
    IgcGeographicMapComponent.prototype.getWindowPoint = function (geographicCoordinate) {
        var iv = this.i.v9(toPoint(geographicCoordinate));
        return fromPoint(iv);
    };
    /**
     * Removes all cached tile images from the map imagery assigned to the map's background content.
    
    */
    IgcGeographicMapComponent.prototype.clearTileCache = function () {
        this.i.vi();
    };
    /**
     * Notifies the chart that the CSS styles in effect have been updated.
    
    */
    IgcGeographicMapComponent.prototype.styleUpdated = function () {
        this.i.vq();
    };
    /**
     * Gets actual window scale for horizontal dimension of the control
    
    */
    IgcGeographicMapComponent.prototype.getActualWindowScaleHorizontal = function () {
        var iv = this.i.gs();
        return (iv);
    };
    /**
     * Gets actual window scale for vertical dimension of the control
    
    */
    IgcGeographicMapComponent.prototype.getActualWindowScaleVertical = function () {
        var iv = this.i.gt();
        return (iv);
    };
    /**
     * Calls for a deferred refresh to the GeographicMap's background.
    
    */
    IgcGeographicMapComponent.prototype.deferredRefresh = function () {
        this.i.deferredRefresh();
    };
    /**
     * Returns the chart visuals expressed as a ChartVisualData object.
    
    */
    IgcGeographicMapComponent.prototype.exportVisualData = function () {
        var iv = this.i.u4();
        return (iv);
    };
    /**
     * Zoom in to the geographic region specified, when possible (may need to wait for map to be initialized).
    
    * @param geographic  * The geographic region to zoom to.
    */
    IgcGeographicMapComponent.prototype.zoomToGeographic = function (geographic) {
        this.i.vx(toRect(geographic));
    };
    Object.defineProperty(IgcGeographicMapComponent.prototype, "imageTilesReady", {
        /**
         * This event is fired whenever the image tiles transition from a loading state (e.g. some are fading in) to a loaded state.
        */
        get: function () {
            return this._imageTilesReady;
        },
        set: function (ev) {
            var _this = this;
            if (this._imageTilesReady_wrapped !== null) {
                this.i.imageTilesReady = delegateRemove(this.i.imageTilesReady, this._imageTilesReady_wrapped);
                this._imageTilesReady_wrapped = null;
                this._imageTilesReady = null;
            }
            this._imageTilesReady = ev;
            this._imageTilesReady_wrapped = function (o, e) {
                var outerArgs = new IgcImageTilesReadyEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeImageTilesReady) {
                    _this.beforeImageTilesReady(_this, outerArgs);
                }
                if (_this._imageTilesReady) {
                    _this._imageTilesReady(_this, outerArgs);
                }
            };
            this.i.imageTilesReady = delegateCombine(this.i.imageTilesReady, this._imageTilesReady_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicMapComponent._observedAttributesIgcGeographicMapComponent = null;
    IgcGeographicMapComponent.htmlTagName = "igc-geographic-map";
    IgcGeographicMapComponent._isElementRegistered = false;
    return IgcGeographicMapComponent;
}(IgcSeriesViewerComponent));
export { IgcGeographicMapComponent };
