import { __extends } from "tslib";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { IgcSizeScaleComponent } from "igniteui-webcomponents-charts";
import { IgcBrushScaleComponent } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { IgcAssigningScatterStyleEventArgs } from "igniteui-webcomponents-charts";
import { IgcAssigningScatterMarkerStyleEventArgs } from "igniteui-webcomponents-charts";
import { IgcGeographicMarkerSeriesComponent } from "./igc-geographic-marker-series-component";
import { GeographicProportionalSymbolSeries } from "./GeographicProportionalSymbolSeries";
import { getAllPropertyNames, toSpinal, ensureBool, ensureEnum, enumToString } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
/**
 * Series class for a geographic map with points marked at given locations.
 * This is the geographic equivalent of a ScatterSeries.
*/
var IgcGeographicProportionalSymbolSeriesComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcGeographicProportionalSymbolSeriesComponent, _super);
    function IgcGeographicProportionalSymbolSeriesComponent() {
        var _this = _super.call(this) || this;
        _this._assigningScatterStyle = null;
        _this._assigningScatterStyle_wrapped = null;
        _this._assigningScatterMarkerStyle = null;
        _this._assigningScatterMarkerStyle_wrapped = null;
        return _this;
    }
    IgcGeographicProportionalSymbolSeriesComponent.prototype.createImplementation = function () {
        return new GeographicProportionalSymbolSeries();
    };
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicProportionalSymbolSeriesComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcGeographicProportionalSymbolSeriesComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent, "observedAttributes", {
        get: function () {
            if (IgcGeographicProportionalSymbolSeriesComponent._observedAttributesIgcGeographicProportionalSymbolSeriesComponent == null) {
                var names = getAllPropertyNames(IgcGeographicProportionalSymbolSeriesComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGeographicProportionalSymbolSeriesComponent._observedAttributesIgcGeographicProportionalSymbolSeriesComponent = names;
            }
            return IgcGeographicProportionalSymbolSeriesComponent._observedAttributesIgcGeographicProportionalSymbolSeriesComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicProportionalSymbolSeriesComponent.register = function () {
        if (!IgcGeographicProportionalSymbolSeriesComponent._isElementRegistered) {
            IgcGeographicProportionalSymbolSeriesComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcGeographicProportionalSymbolSeriesComponent.htmlTagName, IgcGeographicProportionalSymbolSeriesComponent);
        }
    };
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "hasOnlyMarkers", {
        /**
         * Gets whether the series has only marker as visuals
        */
        get: function () {
            return this.i.dy;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "latitudeMemberPath", {
        /**
         * The name of the property of ItemsSource items which contains the latitude coordinate of the symbol.
        */
        get: function () {
            return this.i.v2;
        },
        set: function (v) {
            this.i.v2 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "longitudeMemberPath", {
        /**
         * The name of the property of ItemsSource items which contains the longitude coordinate of the symbol.
        */
        get: function () {
            return this.i.v4;
        },
        set: function (v) {
            this.i.v4 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "radiusMemberPath", {
        /**
         * Gets or sets the radius mapping property for the current series object.
        */
        get: function () {
            return this.i.v9;
        },
        set: function (v) {
            this.i.v9 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "radiusScale", {
        /**
         * Gets or sets the radius size scale for the bubbles.
        */
        get: function () {
            var r = this.i.vg;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcSizeScaleComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.vg = null : this.i.vg = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "labelMemberPath", {
        /**
         * Gets or sets the Label mapping property for the current series object.
        */
        get: function () {
            return this.i.v0;
        },
        set: function (v) {
            this.i.v0 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "fillMemberPath", {
        /**
         * Gets or sets the fill mapping property for the current series object.
        */
        get: function () {
            return this.i.vs;
        },
        set: function (v) {
            this.i.vs = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "fillScale", {
        /**
         * Gets or sets the brush scale for the marker brush.
        */
        get: function () {
            var r = this.i.vd;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgcBrushScaleComponent._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.vd = null : this.i.vd = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "fillScaleUseGlobalValues", {
        /**
         * Gets or sets the whether or not the FillScale uses global values of FillMemberPath of multiple series.
         * This setting applies only if multiple series are using the same FillScale.
        */
        get: function () {
            return this.i.vk;
        },
        set: function (v) {
            this.i.vk = ensureBool(v);
            this._a("fillScaleUseGlobalValues", this.i.vk);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "markerOutlineUsesFillScale", {
        /**
         * Gets or sets whether or not the marker outline should use FillScale like the marker fill does.
         * This setting applies only if the current series has a FillScale set and it overrides MarkerOutline setting.
        */
        get: function () {
            return this.i.vn;
        },
        set: function (v) {
            this.i.vn = ensureBool(v);
            this._a("markerOutlineUsesFillScale", this.i.vn);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "markerOutlineBrightness", {
        /**
         * Gets or sets brightness of the marker outline. Using negative value will change marker outline to darker color and positive value will change marker outline to brighter color
         * Note you can use any values between minimum value of -1 (darkest outline) and maximum value of 1 (brightest outline)
        */
        get: function () {
            return this.i.vq;
        },
        set: function (v) {
            this.i.vq = +v;
            this._a("markerOutlineBrightness", this.i.vq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "markerBrushBrightness", {
        /**
         * Gets or sets brightness of the marker fill. Using negative value will change marker fill to darker color and positive value will change marker fill to brighter color
         * Note you can use any values between minimum value of -1 (darkest fill) and maximum value of 1 (brightest fill)
        */
        get: function () {
            return this.i.vp;
        },
        set: function (v) {
            this.i.vp = +v;
            this._a("markerBrushBrightness", this.i.vp);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "radiusScaleUseGlobalValues", {
        /**
         * Gets or sets the whether or not the RadiusScale uses global values of RadiusMemberPath of multiple series.
         * This setting applies only if multiple series are using the same RadiusScale.
        */
        get: function () {
            return this.i.vo;
        },
        set: function (v) {
            this.i.vo = ensureBool(v);
            this._a("radiusScaleUseGlobalValues", this.i.vo);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "isCustomScatterStyleAllowed", {
        /**
         * Gets or sets whether this Scatter series should allow custom style overrides of its individual visuals.
        */
        get: function () {
            return this.i.vm;
        },
        set: function (v) {
            this.i.vm = ensureBool(v);
            this._a("isCustomScatterStyleAllowed", this.i.vm);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "isCustomScatterMarkerStyleAllowed", {
        /**
         * Gets or sets whether this Scatter series should allow custom style overrides of its individual marker visuals.
        */
        get: function () {
            return this.i.vl;
        },
        set: function (v) {
            this.i.vl = ensureBool(v);
            this._a("isCustomScatterMarkerStyleAllowed", this.i.vl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "itemSearchMode", {
        /**
         * Gets or sets the mode the series will use to find the closest point to the cursor.
        */
        get: function () {
            return this.i.vf;
        },
        set: function (v) {
            this.i.vf = ensureEnum(ScatterItemSearchMode_$type, v);
            this._a("itemSearchMode", enumToString(ScatterItemSearchMode_$type, this.i.vf));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "itemSearchThreshold", {
        /**
         * Gets or sets the threshold to use when searching for items using ItemSearchMode.
        */
        get: function () {
            return this.i.vr;
        },
        set: function (v) {
            this.i.vr = +v;
            this._a("itemSearchThreshold", this.i.vr);
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicProportionalSymbolSeriesComponent.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.radiusScale && this.radiusScale.name && this.radiusScale.name == name) {
            return this.radiusScale;
        }
        if (this.fillScale && this.fillScale.name && this.fillScale.name == name) {
            return this.fillScale;
        }
        return null;
    };
    IgcGeographicProportionalSymbolSeriesComponent.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.radiusScale && this.radiusScale._styling) {
            this.radiusScale._styling(container, component, this);
        }
        if (this.fillScale && this.fillScale._styling) {
            this.fillScale._styling(container, component, this);
        }
        this._inStyling = false;
    };
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "assigningScatterStyle", {
        /**
         * Event raised when Assigning Category Style
        */
        get: function () {
            return this._assigningScatterStyle;
        },
        set: function (ev) {
            var _this = this;
            if (this._assigningScatterStyle_wrapped !== null) {
                this.i.assigningScatterStyle = delegateRemove(this.i.assigningScatterStyle, this._assigningScatterStyle_wrapped);
                this._assigningScatterStyle_wrapped = null;
                this._assigningScatterStyle = null;
            }
            this._assigningScatterStyle = ev;
            this._assigningScatterStyle_wrapped = function (o, e) {
                var outerArgs = new IgcAssigningScatterStyleEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeAssigningScatterStyle) {
                    _this.beforeAssigningScatterStyle(_this, outerArgs);
                }
                if (_this._assigningScatterStyle) {
                    _this._assigningScatterStyle(_this, outerArgs);
                }
            };
            this.i.assigningScatterStyle = delegateCombine(this.i.assigningScatterStyle, this._assigningScatterStyle_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcGeographicProportionalSymbolSeriesComponent.prototype, "assigningScatterMarkerStyle", {
        /**
         * Event raised when Assigning Scatter Marker Style
        */
        get: function () {
            return this._assigningScatterMarkerStyle;
        },
        set: function (ev) {
            var _this = this;
            if (this._assigningScatterMarkerStyle_wrapped !== null) {
                this.i.assigningScatterMarkerStyle = delegateRemove(this.i.assigningScatterMarkerStyle, this._assigningScatterMarkerStyle_wrapped);
                this._assigningScatterMarkerStyle_wrapped = null;
                this._assigningScatterMarkerStyle = null;
            }
            this._assigningScatterMarkerStyle = ev;
            this._assigningScatterMarkerStyle_wrapped = function (o, e) {
                var outerArgs = new IgcAssigningScatterMarkerStyleEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeAssigningScatterMarkerStyle) {
                    _this.beforeAssigningScatterMarkerStyle(_this, outerArgs);
                }
                if (_this._assigningScatterMarkerStyle) {
                    _this._assigningScatterMarkerStyle(_this, outerArgs);
                }
            };
            this.i.assigningScatterMarkerStyle = delegateCombine(this.i.assigningScatterMarkerStyle, this._assigningScatterMarkerStyle_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    IgcGeographicProportionalSymbolSeriesComponent._observedAttributesIgcGeographicProportionalSymbolSeriesComponent = null;
    IgcGeographicProportionalSymbolSeriesComponent.htmlTagName = "igc-geographic-proportional-symbol-series";
    IgcGeographicProportionalSymbolSeriesComponent._isElementRegistered = false;
    return IgcGeographicProportionalSymbolSeriesComponent;
}(IgcGeographicMarkerSeriesComponent));
export { IgcGeographicProportionalSymbolSeriesComponent };
