import { Type } from "igniteui-webcomponents-core";
/**
 * Describes available map styles for the Bing Maps imagery.
 */
export declare enum BingMapsImageryStyle {
    /**
     * Specifies the Aerial map style without road or labels overlay.
     */
    Aerial = 0,
    /**
     * Specifies the Aerial map style with road and labels overlay.
     */
    AerialWithLabels = 1,
    /**
     * Specifies the Roads map style without aerial overlay.
     */
    Road = 2,
    /**
     * Specifies a dark version of the Roads maps.
     */
    CanvasDark = 3,
    /**
     * Specifies a lighter version of the Roads maps.
     */
    CanvasLight = 4,
    /**
     * Specifies a grayscale version of the Roads maps.
     */
    CanvasGray = 5
}
/**
 * @hidden
 */
export declare let BingMapsImageryStyle_$type: Type;
