import { Type } from "igniteui-webcomponents-core";
/**
 * Indicates the desired behavior for the map on resizing.
 */
export declare enum MapResizeBehavior {
    /**
     * Indicates that the map should decide the desired resize mode automatically.
     */
    Auto = 0,
    /**
     * Map will attempt to keep the top left position static during resize.
     */
    MaintainTopLeftPosition = 1,
    /**
     * Map will attempt to keep the center position static during resize.
     */
    MaintainCenterPosition = 2
}
/**
 * @hidden
 */
export declare let MapResizeBehavior_$type: Type;
