import { SeriesViewer } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { DependencyObject } from "igniteui-webcomponents-core";
import { MapResizeBehavior } from "./MapResizeBehavior";
import { MapBackgroundTilingMode } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-webcomponents-core";
import { Base, Point, Type, INotifyPropertyChanged, PropertyChangedEventArgs, IEnumerable } from "igniteui-webcomponents-core";
import { NumericXAxis } from "igniteui-webcomponents-charts";
import { NumericYAxis } from "igniteui-webcomponents-charts";
import { Control } from "igniteui-webcomponents-core";
import { DomRenderer } from "igniteui-webcomponents-core";
import { ScalerParams } from "igniteui-webcomponents-charts";
import { Brush } from "igniteui-webcomponents-core";
import { Series } from "igniteui-webcomponents-charts";
import { SeriesViewerView } from "igniteui-webcomponents-charts";
import { Tuple$2 } from "igniteui-webcomponents-core";
import { ZoomCoercionMode } from "igniteui-webcomponents-charts";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { FontInfo } from "igniteui-webcomponents-core";
import { XamMultiScaleImage } from "igniteui-webcomponents-core";
import { XamMultiScaleTileSource } from "igniteui-webcomponents-core";
import { DownloadingMultiScaleImageEventArgs } from "igniteui-webcomponents-core";
import { CancellingMultiScaleImageEventArgs } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { SeriesView } from "igniteui-webcomponents-charts";
import { ScatterAreaSeries } from "igniteui-webcomponents-charts";
import { InteractionState } from "igniteui-webcomponents-core";
import { ColorScale } from "igniteui-webcomponents-charts";
import { TriangulationStatusEventArgs } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class XamGeographicMap extends SeriesViewer implements IMapRenderDeferralHandler {
    static $t: Type;
    constructor();
    private u3;
    provideContainer(a: any): void;
    me(): void;
    ev(): boolean;
    ew(): boolean;
    uw: boolean;
    static uo: MapResizeBehavior;
    up: MapResizeBehavior;
    us: boolean;
    ut: boolean;
    protected un(): MapBackgroundTilingMode;
    private uk;
    get um(): MapBackgroundTilingMode;
    set um(a: MapBackgroundTilingMode);
    ul: MapBackgroundTilingMode;
    static wb: Rect;
    uz: number;
    uv: boolean;
    uu: boolean;
    wr: Rect;
    private wa;
    get wf(): Rect;
    set wf(a: Rect);
    wj(): Rect;
    private vl;
    private wp;
    get backgroundContent(): GeographicMapImagery;
    set backgroundContent(a: GeographicMapImagery);
    private uh;
    get ue(): NumericXAxis;
    set ue(a: NumericXAxis);
    private ud;
    get ug(): NumericYAxis;
    set ug(a: NumericYAxis);
    private uf;
    uj: GeographicMapImagery;
    private static we;
    getZoomRectFromGeoRect(a: Rect): Rect;
    vv(a: Rect): void;
    vu(a: Rect): void;
    getZoomFromGeographicRect(a: Rect): Rect;
    wg(a: Rect, b: number): Rect;
    private wh;
    getZoomFromGeographicPoints(a: Point, b: Point): Rect;
    wl(a: Rect): Rect;
    v7(a: Point): Point;
    v8(a: Point): Point;
    v9(a: Point): Point;
    vi(): void;
    vo(a: Brush): void;
    fk(): boolean;
    vq(): void;
    protected v6: Point;
    protected vt(): void;
    protected vp(): void;
    protected get_en(): boolean;
    protected wd: Rect;
    protected ts(): Rect;
    lp(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    t2(): Rect;
    private wi;
    protected tt(a: Rect): Rect;
    wk(a: Rect): Rect;
    protected ct(): SeriesViewerView;
    private vk;
    protected n8(a: SeriesViewerView): void;
    oj(a: Rect, b: Rect): void;
    u1: number;
    private uy;
    get u0(): number;
    set u0(a: number);
    gs(): number;
    gt(): number;
    protected pk(): void;
    fc(): boolean;
    ce(): ZoomCoercionMode;
    protected ok(a: any, b: string, c: any, d: any): void;
    imageTilesReady: (sender: any, e: ImageTilesReadyEventArgs) => void;
    private vm;
    private vr;
    private vs;
    uq: XamGeographicMapView;
    private ur;
    getFontInfo(): FontInfo;
    sw(): Brush;
    getFontBrush(): Brush;
    protected pd(a: Series, b: any): void;
    register(a: DependencyObject, b: (arg1: boolean) => void): void;
    unRegister(a: DependencyObject): void;
    deferredRefresh(): void;
    deferAction(a: () => void): void;
    vj(a: boolean): void;
    u4(): any;
    ty(a: Rect, b: Rect, c: Rect): Rect;
    vn(): void;
    private wc;
    protected get wq(): Rect;
    protected set wq(a: Rect);
    vx(a: Rect): void;
    private vw;
    get ux(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class GeographicMapImagery extends Control implements INotifyPropertyChanged {
    static $t: Type;
    constructor(a: XamMultiScaleTileSource);
    protected bb(a: GeographicMapImageryView): void;
    protected ai(): GeographicMapImageryView;
    protected aj: GeographicMapImageryView;
    private ak;
    get deferralHandler(): IMapRenderDeferralHandler;
    set deferralHandler(a: IMapRenderDeferralHandler);
    private a5;
    a9(): void;
    private a3;
    private a2;
    private bg;
    protected ba(a: string, b: any, c: any): void;
    windowRect: Rect;
    get geographicMap(): XamGeographicMap;
    set geographicMap(a: XamGeographicMap);
    static readonly geographicMapProperty: DependencyProperty;
    private static a8;
    private a7;
    clearTileCache(): void;
    imageTilesReady: (sender: any, e: ImageTilesReadyEventArgs) => void;
    private an;
    get ao(): XamMultiScaleImage;
    set ao(a: XamMultiScaleImage);
    ap: XamMultiScaleTileSource;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    bn(a: Size): Size;
    bd(a: RenderingContext): void;
    bf(a: Rect): void;
    be(a: DomRenderer): void;
    imagesChanged: (sender: any, e: ImagesChangedEventArgs) => void;
    private a4;
    a6(): void;
    bc(a: number): void;
    protected v(): void;
    cancellingImage: (sender: any, args: CancellingMultiScaleImageEventArgs) => void;
    downloadingImage: (sender: any, args: DownloadingMultiScaleImageEventArgs) => void;
    referer: string;
    isHorizontalWrappingEnabled: boolean;
    userAgent: string;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicMapImageryView extends Base {
    static $t: Type;
    constructor(a: GeographicMapImagery);
    protected a: GeographicMapImagery;
    e(): void;
    protected j: Rect;
    f(a: RenderingContext): void;
    private d;
    g(a: DomRenderer): void;
    h(a: Rect): void;
    private b;
    get c(): number;
    i(a: number): void;
}
/**
 * @hidden
 */
export declare class GeographicXYTriangulatingSeriesView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicXYTriangulatingSeries);
    protected ch: GeographicXYTriangulatingSeries;
    b5(): void;
    ck(): void;
    cj(): void;
    ci(): void;
    cl(): void;
    cm(): void;
    cn(): void;
    co(): void;
}
/**
 * @hidden
 */
export declare class GeographicScatterAreaSeriesView extends GeographicXYTriangulatingSeriesView {
    static $t: Type;
    constructor(a: GeographicScatterAreaSeries);
    private cp;
    au(): void;
    b5(): void;
    cq(): void;
    cr(): void;
}
/**
 * @hidden
 */
export declare class XamGeographicMapView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamGeographicMap);
    m(a: boolean): InteractionState;
    bk(a: boolean): void;
    protected fn: XamGeographicMap;
    protected get_ap(): boolean;
    d4(): void;
    du(a: RenderingContext): void;
    protected fz: Rect;
    protected dv(a: Rect): void;
    fy(): Rect;
    fs(): void;
    fx: Brush;
    fw: Brush;
    fo: FontInfo;
    fr(a: Rect): void;
    fu(a: GeographicMapImagery, b: GeographicMapImagery): void;
    private ft;
    protected d1(): void;
    fv(a: number): void;
    private fp;
    get fq(): number;
    set fq(a: number);
}
/**
 * @hidden
 */
export declare class OpenStreetMapImagery extends GeographicMapImagery {
    static $t: Type;
    constructor();
    get tilePath(): string;
    set tilePath(a: string);
    static readonly tilePathProperty: DependencyProperty;
    private static br;
    private bq;
}
/**
 * @hidden
 */
export declare abstract class GeographicXYTriangulatingSeries extends GeographicMapSeriesHost {
    static $t: Type;
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    ud: GeographicXYTriangulatingSeriesView;
    uh: string;
    uf: string;
    ue: IEnumerable;
    uk: string;
    um: string;
    uo: string;
    protected pa(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicScatterAreaSeries extends GeographicXYTriangulatingSeries {
    static $t: Type;
    protected bc(): Series;
    protected get_d9(): boolean;
    constructor();
    u3: string;
    private uw;
    get uy(): ColorScale;
    set uy(a: ColorScale);
    private u6;
    u8(): void;
    ux: ColorScale;
    protected qf(): void;
    uz: ScatterAreaSeries;
    protected t4(): Series;
    private u7;
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    u1: GeographicScatterAreaSeriesView;
    protected pa(a: any, b: string, c: any, d: any): void;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    protected get_gg(): boolean;
    protected set_gg(a: boolean): void;
    static $$p: string[];
}
