import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { ArcGISOnlineMapImagery as ArcGISOnlineMapImagery_internal } from "./ArcGISOnlineMapImagery";
/**
 * UI element class used to display ArcGIS Online Map imagery in the IgxGeographicMap.Component
*/
export declare class IgcArcGISOnlineMapImagery extends IgcGeographicMapImagery {
    protected createImplementation(): ArcGISOnlineMapImagery_internal;
    /**
                                 * @hidden
                                 */
    get i(): ArcGISOnlineMapImagery_internal;
    constructor();
    /**
     * Gets or sets the map tile server uri.
    */
    get mapServerUri(): string;
    set mapServerUri(v: string);
    /**
     * Gets or sets the UserName.
    */
    get userName(): string;
    set userName(v: string);
    /**
     * Gets or sets the Password.
    */
    get password(): string;
    set password(v: string);
    /**
     * Gets or sets the UserToken.
    */
    get userToken(): string;
    set userToken(v: string);
    /**
     * Gets or sets the IsMapPublic variable.  A value of false requires authentication parameters.
    */
    get isMapPublic(): boolean;
    set isMapPublic(v: boolean);
    /**
     * Gets or Sets the Default Token Timeout before the Token Expires, this value is in Minutes
    */
    get defaultTokenTimeout(): number;
    set defaultTokenTimeout(v: number);
    /**
     * Gets or Sets the current endpoint to retrieve the token.
    */
    get tokenGenerationEndPoint(): string;
    set tokenGenerationEndPoint(v: string);
    /**
     * Contains the User Supplied Referer Uri to be used in Token Generation.
    */
    get refererUri(): string;
    set refererUri(v: string);
    /**
     * Retreives a new token based on the preconfigured parameters and updates the UserToken field, Normal this is called automatically.
     * The is provided to the end-user to allow them to reteive tokens on their onw.
    
    */
    acquireNewToken(): void;
}
