import { IgcValueBrushScaleComponent } from "igniteui-webcomponents-charts";
import { IgcContourValueResolverComponent } from "igniteui-webcomponents-charts";
import { IgcTriangulationStatusEventArgs } from "igniteui-webcomponents-core";
import { IgcGeographicXYTriangulatingSeriesComponent } from "./igc-geographic-xy-triangulating-series-component";
import { GeographicContourLineSeries } from "./GeographicContourLineSeries";
/**
 * Represents a class for Geographic Contour Series displayed on a map.
*/
export declare class IgcGeographicContourLineSeriesComponent extends IgcGeographicXYTriangulatingSeriesComponent {
    protected createImplementation(): GeographicContourLineSeries;
    /**
                                 * @hidden
                                 */
    get i(): GeographicContourLineSeries;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcGeographicContourLineSeriesComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets whether the current series shows a line contour shape.
    */
    get isLineContour(): boolean;
    /**
     * The name of the property from which to retrieve the numeric values from the ItemsSource items.
    */
    get valueMemberPath(): string;
    set valueMemberPath(v: string);
    /**
     * The ValueBrushScale to use when determining Brushes for each contour line, based on the values found in ValueMemberPath.
    */
    get fillScale(): IgcValueBrushScaleComponent;
    set fillScale(v: IgcValueBrushScaleComponent);
    /**
     * Gets actual fill scale that is set on the FillScale property or default FillScale
    */
    get actualFillScale(): IgcValueBrushScaleComponent;
    set actualFillScale(v: IgcValueBrushScaleComponent);
    /**
     * The ContourValueResolver used to determine the numeric values of contours.
    */
    get valueResolver(): IgcContourValueResolverComponent;
    set valueResolver(v: IgcContourValueResolverComponent);
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    private _triangulationStatusChanged;
    private _triangulationStatusChanged_wrapped;
    /**
     * Raised when the status of an ongoing Triangulation has changed.
    */
    get triangulationStatusChanged(): (s: IgcGeographicContourLineSeriesComponent, e: IgcTriangulationStatusEventArgs) => void;
    set triangulationStatusChanged(ev: (s: IgcGeographicContourLineSeriesComponent, e: IgcTriangulationStatusEventArgs) => void);
}
