import { IgcStyleShapeEventArgs } from "igniteui-webcomponents-charts";
import { IgcGeographicShapeSeriesBaseComponent } from "./igc-geographic-shape-series-base-component";
import { GeographicPolylineSeries } from "./GeographicPolylineSeries";
/**
 * Series class used for displaying multiple polylines, in a geographic context, for datasources which contain multiple lists of points.
*/
export declare class IgcGeographicPolylineSeriesComponent extends IgcGeographicShapeSeriesBaseComponent {
    protected createImplementation(): GeographicPolylineSeries;
    /**
                                 * @hidden
                                 */
    get i(): GeographicPolylineSeries;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcGeographicPolylineSeriesComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets whether the current series shows a polyline shape.
    */
    get isPolyline(): boolean;
    /**
     * Gets or sets the fill brush.
    */
    get shapeFill(): string;
    set shapeFill(v: string);
    /**
     * Gets or sets the stroke brush.
    */
    get shapeStroke(): string;
    set shapeStroke(v: string);
    /**
     * Gets or sets the stroke thickness.
    */
    get shapeStrokeThickness(): number;
    set shapeStrokeThickness(v: number);
    /**
     * Gets or sets the opacity.
    */
    get shapeOpacity(): number;
    set shapeOpacity(v: number);
    ensureShapeStyle(): void;
    private _styleShape;
    private _styleShape_wrapped;
    get styleShape(): (s: IgcGeographicPolylineSeriesComponent, e: IgcStyleShapeEventArgs) => void;
    set styleShape(ev: (s: IgcGeographicPolylineSeriesComponent, e: IgcStyleShapeEventArgs) => void);
}
