import { IgcColorScaleComponent } from "igniteui-webcomponents-charts";
import { IgcTriangulationStatusEventArgs } from "igniteui-webcomponents-core";
import { IgcGeographicXYTriangulatingSeriesComponent } from "./igc-geographic-xy-triangulating-series-component";
import { GeographicScatterAreaSeries } from "./GeographicScatterAreaSeries";
/**
 * Series class which draws a colored 2D surface, in a geographic context, based on a triangulation of XY data with numeric values assigned to each point.
*/
export declare class IgcGeographicScatterAreaSeriesComponent extends IgcGeographicXYTriangulatingSeriesComponent {
    protected createImplementation(): GeographicScatterAreaSeries;
    /**
                                 * @hidden
                                 */
    get i(): GeographicScatterAreaSeries;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcGeographicScatterAreaSeriesComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea(): boolean;
    /**
     * The name of the property on each data item containing a numeric value which can be converted to a color by the ColorScale.
    */
    get colorMemberPath(): string;
    set colorMemberPath(v: string);
    /**
     * The ColorScale used to resolve the color values of points in the series.
    */
    get colorScale(): IgcColorScaleComponent;
    set colorScale(v: IgcColorScaleComponent);
    /**
     * Gets actual color scale that is set on ColorScale property or default ColorScale
    */
    get actualColorScale(): IgcColorScaleComponent;
    set actualColorScale(v: IgcColorScaleComponent);
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Updates ActualColorScale properties using HostedSeries's ColorScale properties
    
    */
    updateActualColorScale(): void;
    private _triangulationStatusChanged;
    private _triangulationStatusChanged_wrapped;
    /**
     * Raised when the status of an ongoing Triangulation has changed.
    */
    get triangulationStatusChanged(): (s: IgcGeographicScatterAreaSeriesComponent, e: IgcTriangulationStatusEventArgs) => void;
    set triangulationStatusChanged(ev: (s: IgcGeographicScatterAreaSeriesComponent, e: IgcTriangulationStatusEventArgs) => void);
}
