import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { IgcImageTilesReadyEventArgs } from "./igc-image-tiles-ready-event-args";
import { IgcGeographicShapeSeriesBaseComponent } from "./igc-geographic-shape-series-base-component";
import { GeographicTileSeries } from "./GeographicTileSeries";
/**
 * Series class used for displaying a tile set, and using shapes to define the areas that should be rendered.
*/
export declare class IgcGeographicTileSeriesComponent extends IgcGeographicShapeSeriesBaseComponent {
    protected createImplementation(): GeographicTileSeries;
    /**
                                 * @hidden
                                 */
    get i(): GeographicTileSeries;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcGeographicTileSeriesComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets whether the current series shows a tile imagery.
    */
    get isTile(): boolean;
    /**
     * The MapImagery which is used to provide the tiles for display.
    */
    get tileImagery(): IgcGeographicMapImagery;
    set tileImagery(v: IgcGeographicMapImagery);
    findByName(name: string): any;
    /**
     * Removes all cached tile Imagery from the
    
    */
    clearTileCache(): void;
    private _imageTilesReady;
    private _imageTilesReady_wrapped;
    /**
     * This event is fired whenever the image tiles transition from a loading state (e.g. some are fading in) to a loaded state.
    */
    get imageTilesReady(): (s: IgcGeographicTileSeriesComponent, e: IgcImageTilesReadyEventArgs) => void;
    set imageTilesReady(ev: (s: IgcGeographicTileSeriesComponent, e: IgcImageTilesReadyEventArgs) => void);
}
