import { IgcGeographicMapSeriesHostComponent } from "./igc-geographic-map-series-host-component";
import { GeographicXYTriangulatingSeries } from "./GeographicXYTriangulatingSeries";
/**
 * Base class for geographic series which triangulate XY data prior to rendering.
*/
export declare abstract class IgcGeographicXYTriangulatingSeriesComponent extends IgcGeographicMapSeriesHostComponent {
    get i(): GeographicXYTriangulatingSeries;
    constructor();
    private static _observedAttributesIgcGeographicXYTriangulatingSeriesComponent;
    static get observedAttributes(): string[];
    private _triangulationDataSource;
    /**
     * Gets or sets the string path specifying the location of the Itf file.
    */
    set triangulationDataSource(value: string);
    get triangulationDataSource(): string;
    private _cachedTriangulationDataSource;
    private updateTriangulationDataSource;
    private onTriangulationDataSourceImportCompleted;
    /**
 * The name of the property from which to extract the Longitude for each item in the ItemsSource.
*/
    get longitudeMemberPath(): string;
    set longitudeMemberPath(v: string);
    /**
     * The name of the property from which to extract the Latitude for each item in the ItemsSource.
    */
    get latitudeMemberPath(): string;
    set latitudeMemberPath(v: string);
    /**
     * The source of triangulation data.
     * This property is optional.  If it is left as null, the triangulation will be created based on the items in the ItemsSource.  Triangulation is a demanding operation, so the runtime performance will be better when specifying a TriangulationSource, especially when a large number of data items are present.
    */
    get trianglesSource(): any[];
    set trianglesSource(v: any[]);
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the first vertex point in the ItemsSource.
    */
    get triangleVertexMemberPath1(): string;
    set triangleVertexMemberPath1(v: string);
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the second vertex point in the ItemsSource.
    */
    get triangleVertexMemberPath2(): string;
    set triangleVertexMemberPath2(v: string);
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the third vertex point in the ItemsSource.
    */
    get triangleVertexMemberPath3(): string;
    set triangleVertexMemberPath3(v: string);
}
