import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { IgcShapeSeriesBaseComponent } from "igniteui-webcomponents-charts";
import { TileSeries } from "./TileSeries";
/**
 * Represents a tile series class that can render imagery tiles
*/
export declare class IgcTileSeriesComponent extends IgcShapeSeriesBaseComponent {
    protected createImplementation(): TileSeries;
    /**
                                 * @hidden
                                 */
    get i(): TileSeries;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcTileSeriesComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets whether the current series shows a tile imagery.
    */
    get isTile(): boolean;
    /**
     * The MapImagery which is used to provide the tiles for display.
    */
    get tileImagery(): IgcGeographicMapImagery;
    set tileImagery(v: IgcGeographicMapImagery);
    findByName(name: string): any;
    /**
     * Defers rendering of the series
    
    */
    deferredRefresh(): void;
}
